      subroutine bendangle(equil,kforce,beta,angle,vangle )
c     *************************************************************
c     *** choose a bond angle                                   ***
c     *** equil is equilibrium bond angle                       ***
c     *** kforce is the force constant                          ***
c     *** beta is 1/kT                                          ***
c     *** angle is the angle returned by this subroutine        ***
c     *** vangle is the energy of the angle                     ***
c     *** M.G. Martin                                           ***
c     *************************************************************

      implicit none
      include 'parallel.inc'

      double precision equil, kforce, beta, angle, vangle, rr, v1, v2
     &     ,random

c      write(6,*) 'start BENDANGLE'

      if ( kforce .gt. 0.1d0 ) then
c        --- find a vector inside the unit sphere
 80      v1 = 2.0d0*random()-1.0d0
         v2 = 2.0d0*random()-1.0d0
         rr = v1*v1 + v2*v2
         if (rr .ge. 1.0d0 ) goto 80
         
c        --- select angle from a gaussian distribution
         angle = equil + v1*dsqrt( (-dlog(rr))
     &        /( kforce*beta*rr) )
         
         if (angle .le. 0.0d0 .or. angle .ge. 3.1415 ) then
            write(istdout,*) 'chose angle outside of 0,Pi in bendangle'
            goto 80
         endif

c        --- correct for the phase space of the angle
         if ( random() .gt. dsin(angle) ) goto 80
         vangle = kforce * (angle - equil)**2
      else
c        --- fixed bond angle
         angle = equil
         vangle = 0.0d0
      endif

c      write(6,*) 'end BENDANGLE'

      return
      end
