      subroutine boltz( lnew,lfirst,lins,ovrlap,i,icharge,imolty,ibox
     &     ,ichoi,iufrom,ntogrow,glist,maxlen)
c
c    *******************************************************************
c    ** calculates the potential energy and the boltzmann factor      **
c    ** for ichoi trial positions.                                    **
c    ** logical ovrlap            true for walk termination           **
c    ** rewritten from old bolzt and boltzu 9-23-97 M.G. Martin       **
c    *******************************************************************
c
      implicit none
 
      include 'control.inc'
      include 'coord.inc'
      include 'system.inc'
      include 'poten.inc'
      include 'neigh.inc'
      include 'cbmc.inc'
      include 'connect.inc'
      include 'qqlist.inc'
      include 'parallel.inc'
 
      logical lnew,ovrlap,lcmno,lfirst,lcompute,lcoulo,lins
      logical lqimol,lqjmol,liji,lqchgi
      integer ichoi,growjj,igrow,count,glist,icharge,cnt
      integer i,imolty,ibox,ntogrow,itrial,ntii,j,jj,ntjj,ntij
     +       ,iu,jmolty,jjj,iufrom,ii,zz,bdmol_b
 
      double precision ljsami,rxui,sr6,ryui,rzui
     +     ,rxuij,ryuij,rzuij,rijsq,sr2,dzui,dz3,dz12
     +     ,exzeo,exsami,exmuir,exgrph,ljpsur,ljmuir,exsix
     +     ,mmff,maxlen,rcm,rcmsq,rcinvdsq,rcinchsq
     +     ,corr,erfunc,rcutmax,rcvdwsq,rcchgsq
      double precision vinter,vintra,vext,velect,vewald,qave,
     &     epsilon2,sigma2,rbmaxij,rbminij
 
      dimension lcmno(nmax),lcoulo(numax,numax)
      dimension glist(numax)
 
c ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
       
c      write(6,*) 'start BOLTZ'
 
c     --- determine the potential cutoffs
      rcvdwsq = rcut*rcut
      rcchgsq = rcutchg(ibox)*rcutchg(ibox)
      rbmaxij = 2d0*rbmax(imolty)
      rbminij = 2d0*rbmin(imolty)
 
      if ( ldual ) then
c        --- use rcutin for both types of interactions (except intra)
         rcinvdsq = rcutin*rcutin
         rcinchsq = rcinvdsq
      else
c        --- compute the cutoffs squared for each interaction
         rcinvdsq = rcvdwsq
         rcinchsq = rcchgsq
 
         if ( lcutcm ) then
c           --- decide which cut-off is longer and use that one
c           --- not needed when ldual is true since will us rcutin then
            if ( rcut .gt. rcutchg(ibox) ) then
               rcutmax = rcut
            else
               rcutmax = rcutchg(ibox)
            endif
         endif
      endif
 
c     --- compute minimum cutoff squared
 
      lqimol = lelect(imolty)
      igrow = nugrow(imolty)
 
      if ( lcutcm .and. (.not. lfirst) ) then
c     --- check previous bead (iufrom) COM for each molecule in the box
         if ( lnew ) then
c           ### for trial chain ###
            rxui  = rxnew(iufrom)
            ryui  = rynew(iufrom)
            rzui  = rznew(iufrom)
         else
c           ### for old chain ###
            rxui  = rxu(i,iufrom)
            ryui  = ryu(i,iufrom)
            rzui  = rzu(i,iufrom)
         endif
          
         do j = 1,nchbox(1)
            lcmno(j) = .false.
            if ( ( nboxi(j) .eq. ibox ) .and. ( i .ne. j ) ) then
               rxuij = rxui-xcm(j)
               ryuij = ryui-ycm(j)
               rzuij = rzui-zcm(j)
               if ( ldual ) then
                  rcm = rcutin + rcmu(j) + maxlen
                  rcmsq = rcm*rcm
               else
                  rcm = rcutmax + rcmu(j) + maxlen
                  rcmsq = rcm*rcm
               endif
c                --- minimum image the pseudo-ctrmas pair separation
               rijsq = rxuij*rxuij + ryuij*ryuij + rzuij*rzuij
               if (rijsq .gt. rcmsq ) lcmno(j) = .true.
            endif
         enddo
      endif
 
      do 20 itrial = 1, ichoi
         lovr(itrial) = .false.
c         ntr_icnt(itrial) = 0
         vinter = 0.0d0
         vintra = 0.0d0
         vext = 0.0d0
         velect = 0.0d0
         vewald = 0.0d0
 
 
c        --- no intramolecular interactions if this is the first bead
         if ( .not. lfirst ) then
 
C *****************************************
C *** INTRACHAIN BEAD-BEAD INTERACTIONS ***
C *****************************************
 
c        --- cycle through molecule and check bead by bead
            do 17 iu = 1, igrow
c           --- see if iu exists in the new chain yet
               if (.not. lexist(iu)) goto 17
             
c           --- loop over all the grown beads
               do count = 1,ntogrow
                  ii = glist(count)
 
c           --- see if iu has nonbonded intramolecular interaction with ii
                  if ( linclu(imolty,ii,iu) ) then
 
c                 --- assign bead type for ii,iu, and the cross term
                     ntii = ntype(imolty,ii)
                     ntjj = ntype(imolty,iu)
                     ntij = (ntii-1)*nntype + ntjj
             
c                 --- determine distances
                     if ( lnew ) then
c                    --- use new trial chain coordinates
                        rxuij  = rxnew(iu) - rxp(count,itrial)
                        ryuij  = rynew(iu) - ryp(count,itrial)
                        rzuij  = rznew(iu) - rzp(count,itrial)
                     else
c                    --- use old chain coordinates
                        rxuij  = rxu(i,iu) - rxp(count,itrial)
                        ryuij  = ryu(i,iu) - ryp(count,itrial)
                        rzuij  = rzu(i,iu) - rzp(count,itrial)
                     endif
                                                                                
                     rijsq = rxuij*rxuij + ryuij*ryuij + rzuij*rzuij
                  endif
 
                  if ( linclu(imolty,ii,iu) ) then
                      
                     if ( rijsq .lt. rminsq ) then
                        lovr(itrial) = .true.
                        goto 19
                     elseif ( rijsq .lt. rcvdwsq .or. lijall) then
                        if ( lhard(ntii) .or. lhard(ntjj) ) then
                           if ( rijsq .lt. sig2ij(ntij) ) then
                              lovr(itrial) = .true.
                              goto 19
                           endif
                        else
                           if (lshift) then
                              sr2 = sig2ij(ntij) / rijsq
                              sr6 = sr2 * sr2 * sr2
                              vintra = vintra + sr6*(sr6-1.0d0)*
     &                             epsij(ntij) - ecut(ntij)
                           else
                              sr2 = sig2ij(ntij) / rijsq
                              sr6 = sr2 * sr2 * sr2
                              vintra = vintra
     &                             + sr6*(sr6-1.0d0)*epsij(ntij)
                           endif
                        endif
                        if ( lqchg(ntii) .and. lqchg(ntjj) ) then
                           velect = velect + qqu(icharge,ii)
     &                             *qqu(icharge,jj)/dsqrt(rijsq)
                        endif
                     endif
                  endif
 
               enddo
 17         continue
 
            vintra = 4.0d0 * vintra
  
c ################################################################
         end if
 
c     grand-canonical: if ibox = 2 (ideal gas box) only intra-chain
         if ( ibox .eq. 1 ) then
 
C *******************************
C *** INTERCHAIN INTERACTIONS ***
C *******************************
c        ---    loop over all chains except i
            do 98 j = 1, nchbox(1)
c           --- check for simulation box
               if ( i .ne. j ) then
                
                  jmolty = moltyp(j)
                  lqjmol = lelect(jmolty)
                  growjj = nugrow(jmolty)
 
                  if ( .not. lfirst ) then
c                 --- check COM table calculated above
                     if (lcmno(j) .and. lcutcm)
     &                    goto 98
                  endif
 
c              --- loop over all beads of molecule i grown this step
 108              do count = 1,ntogrow
c     --- assign bead type for ii
                     ii = glist(count)
                     ntii = ntype(imolty,ii)
                     liji = lij(ntii)
                     lqchgi = lqchg(ntii)
                   
c                 --- assign positions to r*ui
                     rxui = rxp(count,itrial)
                     ryui = ryp(count,itrial)
                     rzui = rzp(count,itrial)
             
                     if ( lfirst .and. lcutcm ) then
c                    --- check if ctrmas within rcmsq
     
                        rxuij = rxui-xcm(j)
                        ryuij = ryui-ycm(j)
                        rzuij = rzui-zcm(j)
 
c                    --- determine cutoff
                        if ( ldual ) then
c                       --- must be lfirst so no previous bead
                           rcm = rcutin + rcmu(j)
                        else
c                       --- standard lcutcm cutoff
                           rcm = rcutmax + rcmu(j)
                        endif
c                    --- check if interaction distance is greater than cutoff
                        rcmsq = rcm*rcm
 
                        rijsq = rxuij*rxuij + ryuij*ryuij + rzuij*rzuij
                        if ( rijsq .gt. rcmsq )
     &                       goto 98
                     endif
c                 --- loop over all beads jj of chain j
                     do 97 jj = 1,nunit(jmolty)
                
c                    --- check exclusion table
                        if ( lexclu(imolty,ii,jmolty,jj) .and.
     &                       jj .ne. leaderq(jmolty,jj) ) goto 97
                      
                        ntjj = ntype(jmolty,jj)
                        ntij = (ntii-1)*nntype + ntjj
 
                        rxuij = rxui - rxu(j,jj)
                        ryuij = ryui - ryu(j,jj)
                        rzuij = rzui - rzu(j,jj)
                      
                        rijsq = rxuij*rxuij + ryuij*ryuij + rzuij*rzuij
 
                        if (jj .eq. leaderq(jmolty,jj)) then
                           if ( rijsq .lt. rcinchsq ) then
                              lcompute = .true.
                           else
                              lcompute = .false.
                           endif
                        endif
 
                        if ( (.not. (liji .and. lij(ntjj)))
     &                       .and.
     &                       (.not. (lqchgi .and. lqchg(ntjj))))
     &                       goto 97
 
c                    --- compute vinter (ex. lennard-jones)
                        if ( rijsq .lt. rminsq ) then
                           lovr(itrial) = .true.
                           goto 19
                        elseif (rijsq .lt. rcinvdsq .or. lijall) then
                           if ( liji .and. lij(ntjj) ) then
                              if ( lhard(ntii) .or. lhard(ntjj) ) then
                                 if ( rijsq .lt. sig2ij(ntij) ) then
                                    lovr(itrial) = .true.
                                    goto 19
                                 endif
                              else
                                 if (lshift) then
                                    sr2 = sig2ij(ntij) / rijsq
                                    sr6 = sr2 * sr2 * sr2
                                    vinter=vinter+sr6*(sr6-1.0d0)*
     +                                   epsij(ntij)- ecut(ntij)
                                 else
                                    sr2 = sig2ij(ntij) / rijsq
                                    sr6 = sr2 * sr2 * sr2
                                    vinter=vinter+sr6*(sr6-1.0d0)*
     +                                   epsij(ntij)
                                 endif
                              endif
                           endif
                        endif
 
c                    --- compute velect (coulomb and ewald)
                        if ( lqimol .and. lqjmol .and.
     &                       lqchg(ntii) .and. lqchg(ntjj) ) then
  
c *** boltz.f has problem to compute the electrostatic interactions
c *** in a group-based way because the leader q might not be grown at
c *** present, so it calculates electrostatic interaction not based on
c *** group but on its own distance in SC, but should be corrected
c *** later by calling energy subroutine.
 
c     --- if lcompute then compute the electrostatic energy
                           if ( lcompute ) then
                              velect = velect + qqu(icharge,ii)
     &                             *qqu(j,jj)/dsqrt(rijsq)
                           endif
                        endif
                         
 97                  continue
                  enddo
               endif
 98         continue
          
            vinter = 4.0d0 * vinter
         end if
c ################################################################
 
C *********************************************
C *** CALCULATION OF TOTAL POTENTIAL ENERGY ***
C *********************************************
  
 19      if ( lovr(itrial) ) then
            bfac(itrial) = 0.0d0
               if ( (.not. lnew) .and. itrial .eq. 1 ) then
                  write(6,*) 'caught here',vtry(itrial)*beta
                  write(6,*) vinter,vintra,vext,velect,vewald
                  do count = 1,ntogrow
                     ii = glist(count)
                     write(6,*) i,ii,rxu(i,ii),ryu(i,ii),rzu(i,ii)
                  enddo
                  do j = 1,nchbox(1)
                     jmolty = moltyp(j)
                     do jj = 1,nunit(jmolty)
                        write(6,'(4f18.6)')
     &                  rxu(j,jj),ryu(j,jj),rzu(j,jj),qqu(j,jj)
                     enddo
                  enddo
                  stop
               endif
                
 
         else
            velect = velect*qqfact
            vewald = vewald*qqfact
            vtry(itrial) = vinter + vintra + vext + velect + vewald
            vtrintra(itrial) = vintra
            vtrext(itrial)   = vext
            vtrinter(itrial) = vinter
            vtrelect(itrial) = velect
            vtrewald(itrial) = vewald
             
            if ( ( vtry(itrial) * beta ) .gt. (2.3d0*softcut) ) then
               if ( (.not. lnew) .and. itrial .eq. 1 ) then
                  write(6,*) 'caught by softcut',vtry(itrial)*beta
                  write(6,*) vinter,vintra,vext,velect,vewald
                  do count = 1,ntogrow
                     ii = glist(count)
                     write(6,*) i,ii,rxu(i,ii),ryu(i,ii),rzu(i,ii)
                  enddo
                  do j = 1,nchbox(1)
                     jmolty = moltyp(j)
                     do jj = 1,nunit(jmolty)
                        write(6,'(4f18.6)')
     &                  rxu(j,jj),ryu(j,jj),rzu(j,jj),qqu(j,jj)
                     enddo
                  enddo
                  stop
               endif
               lovr(itrial) = .true.
               bfac(itrial) = 0.0d0
            elseif ( ( vtry(itrial) * beta ) .lt. -2.303d0*308 ) then
               write(istdout,*)
     &              '### warning: weight too big out of range'
               lovr(itrial) = .true.
               bfac(itrial) = 0.0d0
            else
               bfac(itrial) = dexp ( -(vtry(itrial)*beta) )
            endif
         endif
                                                                                
 20   continue
 
 
 
c ----------------------------------------------------------------------------
      ovrlap = .true.
      do itrial = 1, ichoi
         if ( .not. lovr(itrial)) ovrlap = .false.
      enddo
 
c      write(6,*) 'end BOLTZ'
 
      return
 
      end

