      subroutine coneangle( thetaone, phione, thetatwo, phitwo, angle )
c     ******************************************************************
c     ** takes two unit vectors in spherical coordinates and computes **
c     ** the angle between them.                                      **
c     ** thetaone is the angle between vector one and the z-axis      **
c     ** phione is the angle between vector one and the x-axis        **
c     ** thetatwo is the angle between vector two and the z-axis      **
c     ** phitwo is the angle between vector two and the x-axis        **
c     ** angle is the angle between the two vectors                   **
c     ** x = r sin (theta) cos (phi)                                  **
c     ** y = r sin (theta) sin (phi)                                  **
c     ** z = r cos (theta)                                            **
c     ** M.G. Martin 2-4-98                                           **
c     ******************************************************************

      implicit none
      double precision thetaone, thetatwo, phione, phitwo, angle
     &     ,sintheone,costheone,sinthetwo,costhetwo
     &     ,sinphione,cosphione,sinphitwo,cosphitwo,cosangle

      sintheone = dsin(thetaone)
      costheone = dcos(thetaone)
      sinthetwo = dsin(thetatwo)
      costhetwo = dcos(thetatwo)
      sinphione = dsin(phione)
      cosphione = dcos(phione)
      sinphitwo = dsin(phitwo)
      cosphitwo = dcos(phitwo)
      

      cosangle = sintheone*cosphione*sinthetwo*cosphitwo
     &     + sintheone*sinphione*sinthetwo*sinphitwo
     &     + costheone*costhetwo

      angle = dacos(cosangle)

      return
      end



