C CONTROL.INC
      logical lcluster1,lcluster2,lijall,lchgall
      logical ltailc,lshift,lcutcm,ldual
      integer nmax,nnmax,numax,ntmax,nntype,nvmax,nbxmax,npabmax
      integer nchmax,nchtor_max,nchbn_max

c --------------------------------------------------------------

c *******************************
c *** PARAMETERS FOR ENSEMBLE ***
c *******************************
c if LCLUSTER1=.TRUE. 
c    then simulation is performed for cluster nucleation (the conventional
c    grand-canonical ensemble)
      parameter (lcluster1 = .false.)
c if LCLUSTER2=.TRUE. 
c    then simulation is performed for cluster nucleation (the conventional
c    grand-canonical ensemble plus AVBMC)
      parameter (lcluster2 = .true.)

c ********************************************
c *** PARAMETERS FOR INTERACTION CUT-OFFS  ***
c ********************************************
c if LIJALL = .TRUE.
c    then all i-j-interactions are considered (no potential cut-off)
c    must set lallcm and ltailc to false for lijall = true
      parameter (lijall = .false.)
c if LCHGALL = .TRUE.
c    then all the electrostatic interaction are considered 
c    should set lcutcm and ldual to false for chgall = true
      parameter (lchgall = .false.)
C if LCUTCM=.TRUE. then a cutoff of the centers of mass will be used
c with a value of rcmu as calculated in ctrmas
      parameter (lcutcm = .true.)

c ********************************************
c *** PARAMETERS FOR CBMC-PSEUDO-POTENTIAL ***
c ********************************************
c if LDUAL=.TRUE. then the external potential during a CBMC growth will
c only go out to a radius of rcutin and then will be corrected to the 
c full rcut at the end.  This is Dual Cutoff Configurational-bias Monte 
c Carlo (DC-CBMC)
      parameter (ldual = .true.) 

c ***************************************
c *** PARAMETERS FOR TAIL CORRECTIONS ***
c ***************************************
c if LTAILC=.TRUE. tail corrections are added
c    (WARNING:  .lsami. in external.inc switches an intrinsic
c               tailcorrection on)
      parameter (ltailc = .false.)
c truncated and shifted potentials
      parameter (lshift = .false.)

c ***************************************
c ** DIMENSIONS FOR ARRAYS             **
c ***************************************
c - nmax = maximum number of chains -2
      parameter (nmax = 500)
c - nnmax = maximum type of clusters
      parameter (nnmax = 70000)
c - numax = maximum number of units
      parameter (numax = 12)
c - ntmax = maximum number of types of chains
      parameter (ntmax = 3)
c - nbxmax = maximum number of boxes
      parameter (nbxmax = 2)
c - nntype = number of types of beads
      parameter (nntype = 150)
c - nvmax = maximum number of bond vibration and bending constants
      parameter (nvmax = 100)
c - npabmax = maximum number of box pairs (for swatch and swap) 
      parameter (npabmax = 2)
c - nchmax = maximum number of choices for trial sites in CBMC growth
      parameter (nchmax=100)
c - nchbn_max = maxium number of choices for bending CBMC growth
      parameter (nchbn_max=2000)
c - nchtor_max = maximum number of choices for torsion CBMC growth
      parameter (nchtor_max = 200)









