      subroutine ctrmas ( lall, ibox, j, mtype)

c     ************************************************************
c     ** finds the center of mass of a chain and returns it to  **
c     ** the periodic box if it has left the box.  lall controls**
c     ** whether this is done for just one chain or for the     **
c     ** entire box. ibox is the box of the particle and j is   **
c     ** the particle number.        -Marcus Martin             **
c     ************************************************************

      implicit none

      include 'control.inc'
      include 'coord.inc'

      integer ibox, i,ii,imolty,iunit,j,stt,edd,itype,mtype
      logical lall
      double precision nxcm,nycm,nzcm

      if (lall) then
         stt = 1
         edd = nchbox(1)
      else
         stt = j
         edd = j
      endif

      do i = stt, edd
         imolty = moltyp(i)
         iunit = nunit(imolty)

c ----- Determine new center of mass for chain i 
 25      nxcm = 0.0d0
         nycm = 0.0d0
         nzcm = 0.0d0
         do ii = 1, iunit
            itype = ntype(imolty,ii)
            nxcm = nxcm + rxu(i,ii) * mass(itype)
            nycm = nycm + ryu(i,ii) * mass(itype)
            nzcm = nzcm + rzu(i,ii) * mass(itype)
         enddo
         xcm(i) = nxcm / masst(imolty)
         ycm(i) = nycm / masst(imolty)
         zcm(i) = nzcm / masst(imolty)
      enddo

      return
      end


