      subroutine energy ( i,imolty, v, vintra, vinter,vext
     &     ,velect,vewald,flagon,ibox, istart, iend,lljii,ovrlap
     &     ,ltors,vtors,lcharge_table)
  
c    *******************************************************************
c    ** calculates the total potential energy for a configuration.    **
c    *******************************************************************
  
      implicit none
 
c *** common blocks ***
      include 'control.inc'
      include 'coord.inc'
      include 'system.inc'
      include 'inputdata.inc'
      include 'poten.inc'
      include 'coord2.inc'
      include 'connect.inc'
      include 'qqlist.inc'
      include 'neigh.inc'
      include 'parallel.inc'
 
      logical lcoulo,lij2,liji,lqchgi
      logical lljii,ovrlap,ltors,lcharge_table
 
      integer growii,growjj
      integer i,ibox, istart, iend,ii,ntii,flagon,jjj,iii
     +       ,j,jj,ntjj,ntij,imolty,jmolty,k
      integer iivib,jjtor,ip1,ip2,ip3,it,nchp2
 
      double precision v,vintra, vinter,vext
     +                ,rxui,rzui,ryui,rxuij,rcinsq
     +                ,ryuij,rzuij,sr2,sr6,rij,rijsq,dzui,dz3,dz12
     +                ,vtors,velect,vewald,rxij,ryij,rzij
      double precision xvec,yvec,zvec,xaa1,yaa1,zaa1,xa1a2,ya1a2,za1a2
     &     ,daa1,da1a2,dot,thetac,vtorso
      double precision xcmi,ycmi,zcmi,rcmi,rcm,rcmsq
 
      dimension xvec(numax,numax),yvec(numax,numax),zvec(numax,numax)
      dimension lcoulo(numax,numax)
 
      double precision vij,viijj,vqiijj
C --------------------------------------------------------------------
 
c      write(6,*) 'start ENERGY'
 
      v = 0.0d0
      vinter = 0.0d0
      vintra = 0.0d0
      vext = 0.0d0
      velect = 0.0d0
      vewald = 0.0d0
      vtors = 0.0d0
      ovrlap = .false.
      vij = 0.0d0
      viijj = 0d0
      vqiijj = 0d0
      if ( istart .eq. 1 ) then
         if ( flagon .eq. 2) then
            neigh_icnt = 0
            neigh_icnt2 = 0
         endif
         if ( lene_w ) then
            do j = 1,nchbox(ibox)
               ene3(j,flagon) = 0d0
               ene4(j,flagon) = 0d0
            enddo
            ene3(i,flagon) = 0d0
            ene4(i,flagon) = 0d0
         endif
      endif
 
C *******************************
C *** INTERCHAIN INTERACTIONS ***
C *******************************
 
cc     --- loop over all chains except i - not for grand can. with ibox=2 !
      do 98 j = 1, nchbox(ibox)
             
         jmolty = moltyp(j)
         growjj = nugrow(jmolty)
 
c ### check for simulation box ###
         if (i .ne. j ) then
             
c              --- loop over all beads ii of chain i
 108        do ii = istart, iend
               ntii = ntype(imolty,ii)
               liji = lij(ntii)
               lqchgi = lqchg(ntii)
               rxui = rxuion(ii,flagon)
               ryui = ryuion(ii,flagon)
               rzui = rzuion(ii,flagon)
                   
c                 --- loop over all beads jj of chain j
               do 97 jj = 1, nunit(jmolty)
                      
                  if (lexclu(imolty,ii,jmolty,jj)) goto 97
                  ntjj = ntype(jmolty,jj)
                  ntij = (ntii-1)*nntype + ntjj
 
                  rxuij = rxui - rxu(j,jj)
                  ryuij = ryui - ryu(j,jj)
                  rzuij = rzui - rzu(j,jj)
                   
                  rijsq = rxuij*rxuij+ryuij*ryuij+rzuij*rzuij
 
                  if ( rijsq .lt. rminsq ) then
                     ovrlap = .true.
                     return
                  endif
                  if ( liji .and. lij(ntjj) ) then
                     if ( lhard(ntii) .or. lhard(ntjj) ) then
                        if ( rijsq .lt. sig2ij(ntij) ) then
                           ovrlap = .true.
                           return
                        else
                           viijj = 0d0
                        endif
                     else
                        if (lshift) then
                           sr2 = sig2ij(ntij) / rijsq
                           sr6 = sr2 * sr2 * sr2
                           vinter = vinter + sr6*(sr6-1.0d0)
     &                          *epsij(ntij)-ecut(ntij)
                        else
                           sr2 = sig2ij(ntij) / rijsq
                           sr6 = sr2 * sr2 * sr2
                           viijj = sr6*(sr6-1.0d0)*epsij(ntij)
                           vinter = vinter + viijj
                           if ( lene_w ) then
                              ene3(i,flagon) = ene3(i,flagon)+viijj
                              ene3(j,flagon) = ene3(j,flagon)+viijj
                           endif
                        endif
                               
                     endif
                         
                  endif
 
c                    --- electrostatics
                  if ( lqchgi .and. lqchg(ntjj) ) then
                     vqiijj=qquion(ii,flagon)*qqu(j,jj)/dsqrt(rijsq)
                     velect = velect + vqiijj
                     if ( lene_w ) then
                        ene4(i,flagon) = ene4(i,flagon) + vqiijj
                        ene4(j,flagon) = ene4(j,flagon) + vqiijj
                     endif
 
                  endif
 
                      
                  if ( flagon .eq. 2 ) then
                     if ( ii .eq. 1 .and. jj .eq. 1 ) then
                        if ( rijsq .lt. rbsmaxsq(imolty,jmolty) .and.
     &                       rijsq .gt. rbsminsq(imolty,jmolty)) then
                           neigh_icnt=neigh_icnt+1
                           neighi(neigh_icnt)=j
                        endif
                     endif
 
                     if ( lene_cut ) then
                        vij = vij + viijj*4d0+vqiijj*qqfact
                        viijj = 0.0d0
                        vqiijj = 0d0
                     endif
                      
                  endif
 
 97            continue
            enddo
            if ( lene_cut ) then
               if ( vij .lt. ene_cut(imolty,jmolty)) then
                  neigh_icnt2=neigh_icnt2+1
                  neighi2(neigh_icnt2)=j
               endif
               vij = 0.0d0
            endif
         endif
 98   continue
 
c      write(6,*) vinter
      vinter = 4.0d0 * vinter
c ################################################################
 
      if (lljii) then
c * the intramolecular van der waals and ewald terms have to be calculated
c for the explicit atom placement models
C *******************************
C *** INTRACHAIN INTERACTIONS ***
C *******************************
       
c --- calculate intramolecular energy correction for chain i
         do ii = istart, iend
             
            ntii = ntype(imolty,ii)
            rxui = rxuion(ii,flagon)
            ryui = ryuion(ii,flagon)
            rzui = rzuion(ii,flagon)
            liji = lij(ntii)
            lqchgi = lqchg(ntii)
             
            do jj = 1,ii-1
                
               ntjj = ntype(imolty,jj)
               ntij = (ntii-1)*nntype + ntjj
               if ( linclu(imolty,ii,jj) ) then
                  rxuij = rxuion(ii,flagon) - rxuion(jj,flagon)
                  ryuij = ryuion(ii,flagon) - ryuion(jj,flagon)
                  rzuij = rzuion(ii,flagon) - rzuion(jj,flagon)
                
                  rijsq = rxuij*rxuij + ryuij*ryuij + rzuij*rzuij
                   
                  if ( rijsq .lt. rminsq ) then
                     write(istdout,*) 'rijsq:',rijsq,rminsq
                     ovrlap = .true.
                     return
                  endif
                  if ( lhard(ntii) .or. lhard(ntjj) ) then
                     if ( rijsq .lt. sig2ij(ntij) ) then
                        ovrlap = .true.
                        return
                     endif
                  else
                     if ( liji .and. lij(ntjj) ) then
                        if (lshift) then
                           sr2 = sig2ij(ntij) / rijsq
                           sr6 = sr2 * sr2 * sr2
                           vintra = vintra +
     +                         sr6*(sr6-1.0d0)*epsij(ntij)-ecut(ntij)
                        else
                           sr2 = sig2ij(ntij) / rijsq
                           sr6 = sr2 * sr2 * sr2
                           vintra = vintra +
     +                          sr6*(sr6-1.0d0)*epsij(ntij)
                        endif
                     endif
                  endif
                  if ( lqchgi .and. lqchg(ntjj) ) then
                     velect = velect+qquion(ii,flagon)*
     &                    qquion(jj,flagon)/dsqrt(rijsq)
                  endif
               endif
            enddo
         enddo
         vintra = 4.0d0 * vintra
 
      endif
 
c ################################################################
 
c *********************************************************************
c *** calculation of torsion energy for explicit atom methy groups ****
c *********************************************************************
 
      if ( ltors ) then
         do ii = 1, nunit(imolty)
            rxui=rxuion(ii,flagon)
            ryui=ryuion(ii,flagon)
            rzui=rzuion(ii,flagon)
            do iivib = 1, invib(imolty,ii)
               jj = ijvib(imolty,ii,iivib)
               xvec(ii,jj) = rxuion(jj,flagon) - rxui
               yvec(ii,jj) = ryuion(jj,flagon) - ryui
               zvec(ii,jj) = rzuion(jj,flagon) - rzui
c              --- account for explicit atoms in opposite direction
               xvec(jj,ii)   = -xvec(ii,jj)
               yvec(jj,ii)   = -yvec(ii,jj)
               zvec(jj,ii)   = -zvec(ii,jj)
            enddo
         enddo
 
         do j = nugrow(imolty)+1, nunit(imolty)
            do jjtor = 1, intor(imolty,j)
               ip3 = ijtor4(imolty,j,jjtor)
               if ( ip3 .lt. j ) then
                  ip1 = ijtor2(imolty,j,jjtor)
                  ip2 = ijtor3(imolty,j,jjtor)
                  it  = ittor(imolty,j,jjtor)
c*** calculate cross products d_a x d_a-1 and d_a-1 x d_a-2 ***
                  xaa1 = yvec(ip1,j) * zvec(ip2,ip1) +
     +                 zvec(ip1,j) * yvec(ip1,ip2)
                  yaa1 = zvec(ip1,j) * xvec(ip2,ip1) +
     +                 xvec(ip1,j) * zvec(ip1,ip2)
                  zaa1 = xvec(ip1,j) * yvec(ip2,ip1) +
     +                 yvec(ip1,j) * xvec(ip1,ip2)
                  xa1a2 = yvec(ip1,ip2) * zvec(ip2,ip3) +
     +                 zvec(ip1,ip2) * yvec(ip3,ip2)
                  ya1a2 = zvec(ip1,ip2) * xvec(ip2,ip3) +
     +                 xvec(ip1,ip2) * zvec(ip3,ip2)
                  za1a2 = xvec(ip1,ip2) * yvec(ip2,ip3) +
     +                 yvec(ip1,ip2) * xvec(ip3,ip2)
c *** calculate lengths of cross products ***
                  daa1 = dsqrt(xaa1**2+yaa1**2+zaa1**2)
                  da1a2 = dsqrt(xa1a2**2+ya1a2**2+za1a2**2)
c *** calculate dot product of cross products ***
                  dot = xaa1*xa1a2 + yaa1*ya1a2 + zaa1*za1a2
                  thetac = - dot / ( daa1 * da1a2 )
                  vtors = vtors + vtorso( thetac, it )
               endif
            enddo
         enddo
      endif
                                                                                
C ----------------------------------------------------------------------------
      velect = velect * qqfact
 
c     note that vintra are only computed when the flag lljii is true
      v = vinter + vext + vintra + velect
 
c      write(6,*) 'end ENERGY'
 
 
      return
      end
 

