      subroutine inclus( inclnum,inclmol,inclbead,inclsign,ncarbon)

      implicit none

      include 'control.inc'
      include 'coord.inc'
      include 'connect.inc'
      include 'parallel.inc'

      integer m,n,nb,mb,imolty,ioffset
      integer inclnum,inclmol,inclbead,inclsign,ncarbon
      dimension inclmol(ntmax*numax*numax),inclsign(ntmax*numax*numax)
      dimension inclbead(ntmax*numax*numax,2),ncarbon(ntmax)

c ----------------------------------------------------------------

      write(istdout,*) 
      write(istdout,*) 'INCLUSION TABLE'

c - triple loop over all types of molecules -
      do imolty = 1, nmolty

         do m = 1, nunit(imolty)
            do n = 1, nunit(imolty)
               linclu(imolty,m,n) = .true.
            enddo
         enddo
         
c - double loop over all units -
         do m = 1, nunit(imolty)

c - exclude all self interactions -
            linclu(imolty,m,m) = .false.
c - exclude all directly bonded beads (vibrations) -
            do n = 1, invib(imolty,m)
               nb = ijvib(imolty,m,n)
               linclu(imolty,m,nb) = .false.
            enddo
c - exclude carbons around a quaternary center for explct
            if (invib(imolty,m) .eq. 4) then
               do n = 1,4
                  do nb = 1,4
                     linclu(imolty,ijvib(imolty,m,n)
     &                    ,ijvib(imolty,m,nb))=.false.
                  enddo
               enddo
            endif
                  
c - exclude all next-nearest neighbor bonded beads (bending) -
            do n = 1, inben(imolty,m)
               nb = ijben3(imolty,m,n)
               linclu(imolty,m,nb) = .false.
            enddo
c - exclude all third-nearest neighbor bonded beads (torsions) -
            do n = 1, intor(imolty,m)
               nb = ijtor4(imolty,m,n)
               linclu(imolty,m,nb) = .false.
            enddo

         enddo

c     - include or exculde additional beads accoring to incl
         do n = 1,inclnum
            if ( inclmol(n) .eq. imolty ) then
               m = inclbead(n,1)
               nb = inclbead(n,2)
               if ( inclsign(n) .eq. 1 ) then
                  linclu(imolty,m,nb) = .true.
                  linclu(imolty,nb,m) = .true.
               elseif (inclsign(n) .eq. -1 ) then
                  linclu(imolty,m,nb) = .false.
                  linclu(imolty,nb,m) = .false.
               else
                  write(istdout,*) 'INCLUS: n,inclsign(n)',n,inclsign(n)
                  stop 'inclusign must be 1 or -1'
               endif
            endif
         enddo

c - exclude all hydrogens that have their carbons excluded 
         if ( ncarbon(imolty) .lt. nunit(imolty) ) then
            if (ncarbon(imolty) .eq. 3 .and. nunit(imolty) .eq. 8) then
c - ethane with bead 3 being hydrogen
               ioffset = 0
            else
               ioffset = 1
            endif
            do m = ncarbon(imolty)+ioffset,nunit(imolty)
c - hydrogens only have one vibration and that is to the C atom               
               mb = ijvib(imolty,m,1)
               do nb = 1, ncarbon(imolty)
                  if ( .not. linclu(imolty,mb,nb) ) then
                     linclu(imolty,m,nb) = .false.
                     linclu(imolty,nb,m) = .false.
                  endif
               enddo
               do n=m+1,nunit(imolty)
                  nb = ijvib(imolty,n,1)
                  linclu(imolty,n,nb) = .false.
                  linclu(imolty,nb,n) = .false.
                  if ( .not. linclu(imolty,mb,nb) ) then
                     linclu(imolty,m,n) = .false.
                     linclu(imolty,n,m) = .false.
                     linclu(imolty,m,nb) = .false.
                     linclu(imolty,nb,m) = .false.
                     linclu(imolty,n,mb) = .false.
                     linclu(imolty,mb,n) = .false.
                  endif
               enddo
            enddo
         endif

         do m = 1, nunit(imolty)
            write(istdout,*) m, (linclu(imolty,m,n),n=1,nunit(imolty))
         enddo
         write(istdout,*) 

      enddo
      write(istdout,*) 'finished inclus'
      return
      end






