      program main
 
      implicit none
 
      include 'mpif.h'
      include 'parallel.inc'
 
      integer i
      double precision random,rtest
      dimension rtest(10)
 
c --- parallel code stuff
      CALL MPI_INIT(ierr)
      CALL MPI_COMM_RANK(MPI_COMM_WORLD,myid,ierr)
      CALL MPI_COMM_SIZE(MPI_COMM_WORLD,Nproc,ierr)
 
c ----------------------------------------------------------------
 
      if ( Nproc .eq. 1 ) then
         iinpara = 4
         istdout = 6
         iinconf = 77
         imovie = 10
         ibias = 7
         ifinconf = 8
         ihist1 = 61
         ihist2 = 62
         ihist3 = 63
         iradg = 51
		 idensity = 90
		 imoment = 91
c      elseif ( Nproc .le. 10 ) then
c         iinpara = 4
c         istdout = 10+myid
c         imovie = 20+myid
c         ibias = 7
c         ifinconf = 60+myid
c         iinconf = 70+myid
c         ihist1 = 40+myid
c         ihist2 = 50+myid
c         iradg = 30+myid
      elseif ( Nproc .le. 100 ) then
         iinpara = 4
         istdout = 100+myid
         imovie = 200+myid
         ibias = 7
         ifinconf = 800+myid
         iinconf = 700+myid
         ihist1 = 400+myid
         ihist2 = 500+myid
         ihist3 = 600+myid
         iradg = 300+myid
		 idensity = 900+myid
		 imoment = 950+myid
      else
         stop 'the maximum number of processes allowed (10) is exceeded'
      endif
 
c --- initialize random number generator
      read(iinpara,*)
      read(iinpara,*) i

      call sgrnd(myid+i*31)
 
c --- print 10 random numbers for control ---
      do i=1,10
         rtest(i) = random()
      enddo
      write(istdout,1000) (rtest(i),i=1,5)
      write(istdout,1000) (rtest(i),i=6,10)
 1000 format(2x,5f10.6)
 
c --- call main program
      call nucleation
 
      CALL MPI_FINALIZE(ierr)
c ----------------------------------------------------------------
 
      stop
      end

