      subroutine nucleation 

C -----------------------------------------------------------------
C subroutine nucleation
C - starts and controls the simulation
C -----------------------------------------------------------------

      implicit none

      include 'control.inc'
      include 'coord.inc'
      include 'coord2.inc'
      include 'bnbsma.inc'
      include 'inputdata.inc'
      include 'cbmc.inc'
      include 'ensemble.inc'
      include 'neigh.inc'
      include 'parallel.inc'
      include 'poten.inc'

      logical ovrlap
      integer i,j,im,imolty,ibox,inb,nend,nnn,ii,clusize,iunit,jbox_max,
     &     jbox,k,kk,jj
      double precision qelect(0:nntype)
      double precision acmove,random,rm,pscb1,pscb2,vstart(0:nbxmax),
     &     vend(0:nbxmax),rm1,rm2
      double precision hist_num(0:nmax),hist_num2(0:nnmax),
     & hist_ene(0,0:9999),sumrad(0:nmax),hist_num3(0:2000,0:2000),
     &     sumk(0:nnmax),sume(0:nnmax)
      double precision v,vinter,vtail,vintra,vvib,vbend,vtg,vext,velect,
     &     vflucq
      double precision bnswap(ntmax,npabmax,nbxmax*2),
     &     bsswap(ntmax,npabmax,nbxmax*2)

      call readdat(qelect)

      do i = 1,nmax
         hist_num(i) = 0d0
c         do j = 1,10000
c            hist_ene(i,j) = 0d0
c         enddo
      enddo
      do i = 0,nnmax
         hist_num2(i) = 0d0
         sumk(i) = 0d0
         sume(i) = 0d0
      enddo
      if ( lhist_gram ) then
         do i = 1,nnmax
            do j = 0,9999
               hist_ene(i,j) = 0d0
            enddo
         enddo
      endif

      do i = 1,120
         do j = 1,120
            hist_num3(i,j) = 0d0
         enddo
      enddo

      acmove = 0.0d0

c *** temporary accumulators for max. displacement updates ***
      do im=1,nbox
         do imolty = 1,nmolty
            bstrax(imolty,im) = 0.0d0
            bstray(imolty,im) = 0.0d0
            bstraz(imolty,im) = 0.0d0
            bsrotx(imolty,im) = 0.0d0
            bsroty(imolty,im) = 0.0d0
            bsrotz(imolty,im) = 0.0d0
            bntrax(imolty,im) = 0.0d0
            bntray(imolty,im) = 0.0d0
            bntraz(imolty,im) = 0.0d0
            bnrotx(imolty,im) = 0.0d0
            bnroty(imolty,im) = 0.0d0
            bnrotz(imolty,im) = 0.0d0
         enddo
      enddo

c *** temporary accumulators for conf.bias performance ***
      do i = 1, nmolty
         do j = 1,nswapb(i)
            do ibox = 1, 2*nbox
               bsswap(i,j,ibox) = 0.0d0
               bnswap(i,j,ibox) = 0.0d0
            enddo
         enddo
         do inb = 1, numax
            bncb ( i,inb ) = 0.0d0
            bscb ( i,1,inb ) = 0.0d0
            bscb ( i,2,inb ) = 0.0d0
         enddo
      enddo
 
C -----------------------------------------------------------------

      ibox = 1
      call sumup( ovrlap, v, vinter,vtail, vintra,vvib,
     +     vbend,vtg,vext,velect,vflucq, 1)
      vbox(ibox) = v
      vinterb(ibox)  = vinter
      vtailb(ibox)   = vtail
      vintrab(ibox)  = vintra
      vvibb(ibox)    = vvib  
      vbendb(ibox)   = vbend
      vtgb(ibox)     = vtg  
      vextb(ibox)    = vext 
      velectb(ibox)  = velect
      vflucqb(ibox)  = vflucq
      
      if( ovrlap ) then
         write(istdout,*) ' overlap in initial configuration '
         stop
      endif
      vstart(ibox) = vbox(ibox)
      write(istdout,*)
      write(istdout,*) 'box  ',ibox,' initial v   = ', vbox(ibox)

      write(istdout,*)
      write(istdout,*) '+++++ start of markov chain +++++'
      write(istdout,*)
      write(istdout,*) 
     & 'Cycle   Total   Energy    Boxlength   Pressure  Molecules'
c     set up info at beginning of fort.12 for analysis

c *******************************************************************
c ** loops over all cycles and all molecules                       **
c *******************************************************************
 
      nend = nnstep + nstep

c *** use the following output for debug

      write(21,*) (neigh_cnt(i),i=1,nchbox(1))
      do i = 1,nchbox(1)
         write(21,*) (neighbor(j,i),j=1,neigh_cnt(i))
      enddo
      if (lene_cut) then
         write(41,*) (neigh_cnt2(i),i=1,nchbox(1))
         do i = 1,nchbox(1)
            write(41,*) (neighbor2(j,i),j=1,neigh_cnt2(i))
         enddo
      endif

      do 100 nnn = 1, nstep

         do 99 ii = 1, 100 

c ***       select a move-type at random ***
            rm = random()
c ###       special ensemble dependent moves ###
            acmove = acmove + 1.0d0

            if ( rm .le. pmswap ) then
c            elseif ( rm .le. pmswap ) then
c           --- swap move for linear and branched molecules ---
c               write(6,*) ii,'swap move'
               call swap(bsswap,bnswap,qelect)
            elseif ( rm .le. pmcb ) then
c               write(6,*) ii,'CBMC move'
c           --- configurational bias move ---
               call config

            elseif ( rm .le. pmtra ) then
c               write(6,*) ii,'trans'
c           --- translational move in x,y, or z direction ---
               rm = 3.0d0 * random()
               if ( l2d ) then
                  rm1 = 1.5d0
                  rm2 = 3d0
               else
                  rm1 = 1d0
                  rm2 = 2d0
               endif
               if ( rm .le. rm1 ) then
		  call traxyz (.true.,.false.,.false.)
               elseif ( rm .le. rm2 ) then
		  call traxyz (.false.,.true.,.false.)
               else
		  call traxyz (.false.,.false.,.true.)
               endif

            else
c               write(6,*) ii,'rot'
c           --- rotation around x,y, or z axis move --
               rm = 3.0d0 * random()
               if ( rm .le. 1.0d0 ) then
                   call rotxyz(.true.,.false.,.false.)
               elseif ( rm .le. 2.0d0 ) then
                   call rotxyz(.false.,.true.,.false.)
               else
                   call rotxyz(.false.,.false.,.true.)
               endif
            endif

c ***       calculate instantaneous values ***
c ***       accumulate averages ***
                        
            clusize = nchbox(1)

c            if ( lene_w ) then
c               do i = 1,clusize
c               j = dint((ene1(i)+15d0)/0.002d0)+1
c                  j = dint(-(ene1(i)*4d0+ene2(i)*qqfact)/5d0)+1
c                  if ( j .le. 0 ) j = 1
c                  if ( j .ge. 20000 ) j = 20000
c                  hist_ene2(j) = hist_ene2(j)+1d0
c               enddo
c            endif

c            write(6,*) 'clusize:',clusize
            hist_num(clusize) = hist_num(clusize)+1d0
            if ( nmolty .eq. 1 ) then
               i = ncmt(1,1)
               j = 0
               k = 0
            elseif ( nmolty .eq. 2 ) then
               i = ncmt(1,1)
               j = ncmt(1,2)
               k = 0
            else
               i = ncmt(1,1)
               j = ncmt(1,2)
               k = ncmt(1,3)
            endif

            if ( lhomo ) then
               jj = (i*(n2+1)+j)*(n3+1)+k
               hist_num2(jj) = hist_num2(jj)+1d0
               kk = dint((-(vinterb(1)+velectb(1)))/20d0)+1
               sumk(jj) = sumk(jj)+kk
               sume(jj) = sume(jj)-(vinterb(1)+velectb(1))
               if ( lhist_gram ) then
                  j = (i*(n2+1)+j)*(n3+1)+k
                  jj = mod(kk,10000)
                  hist_ene(j,jj) = hist_ene(j,jj) + 1d0
               endif
            else
               i = dint(dsqrt((rxu(2,1)-rxu(2,8))**2+(ryu(2,1)-
     &              ryu(2,8))**2+(rzu(2,1)-rzu(2,8))**2)/0.1d0)+1
               hist_num3(clusize,i) = hist_num3(clusize,i)+1d0
            endif

c            write(91,*) nchbox(1)
c            write(91,*) (neigh_cnt(i),i=1,nchbox(1))
c            do i = 1,nchbox(1)
c               if ( neigh_cnt(i) .gt. 0 ) then
c               write(91,*) (neighbor(j,i),j=1,neigh_cnt(i))
c               endif
c            enddo

c            do i = 1,nchbox(1)
c               write(6,*) parpt(i),parbox(parpt(i),1,moltyp(i)),i,
c     &              moltyp(i)
c            enddo

c *************************************************************
c ** ends loop over chains                                   **
c *************************************************************

99       continue
         
         if ( mod(nnn,iprint) .eq. 0 ) then
            write(istdout,'(i9,e12.4,15i4)') nnn,
     +           vbox(1),
     +           (ncmt(1,imolty),imolty=1,nmolty),clusize
         endif

         if ( mod(nnn,imv) .eq. 0 ) then
            write(imovie) nnn
            write(imovie) nchbox(1)
            do i = 1,nchbox(1)
               imolty = moltyp(i)
               iunit = nunit(imolty)
c               write(imovie,1015) i,imolty,iunit,1,xcm(i),ycm(i),zcm(i)
c 1015          format(4i5,3f15.6)
               write(imovie) i,imolty,iunit,1
               write(imovie) xcm(i),ycm(i),zcm(i)
               do ii = 1,iunit
c                  write(imovie,1012) rxu(i,ii), ryu(i,ii), rzu(i,ii)
c     &                 , qqu(i,ii),ntype(imolty,ii)
c 1012             format(4f15.6,i5)
                  write(imovie) rxu(i,ii), ryu(i,ii), rzu(i,ii)
               enddo
            enddo
         endif
 
         if ( mod(nnn,iblock) .eq. 0 ) then
c            write(ihist1,*) n0,1d0
            if ( lradgyr ) write(iradg,*) sumrad(1)/hist_num(1)
            do i = 1,nsum
               if ( hist_num(i) .gt. 0.5d0 ) then
                  if (lradgyr) write(iradg,*) sumrad(i)/hist_num(i)
                  write(ihist1,*) i,hist_num(i)
               endif
            enddo
            if ( lhomo ) then
               do i = 0,n1
                  do j = 0,n2
                     do k = 0,n3
                        jj = (i*(n2+1)+j)*(n3+1)+k
                        if ( hist_num2(jj) .gt. 0.5d0 ) then
                           write(ihist2,'(3i5,f12.0,2f18.6)') i,j,k,
     &                          hist_num2(jj),sumk(jj)/hist_num2(jj),
     &                          sume(jj)/hist_num2(jj)
                        else
                           write(ihist2,'(3i5,3f12.0)') 
     &                          i,j,k,hist_num2(jj),0d0,0d0
                        endif
                        if ( lhist_gram ) then
                           jj = (i*(n2+1)+j)*(n3+1)+k
                           do kk = 0,9999
                              if (hist_ene(jj,kk) .gt. 0.5d0 ) then
c                              if ( hist_num2(i,j) .gt. 0.5d0 ) then
                                 write(ihist3,*) kk, 
     &                                hist_ene(jj,kk)
c                              else
c                                 write(istdout,*) 'error',i,j,k,kk,
c     &                           hist_num2(i,j),hist_ene(k,kk) 
c                              endif
                              endif 
                           enddo
                           write(ihist3,*) 10000,0d0
                        endif
                     enddo
                  enddo
               enddo
            else
               do i = 0,n1
                  do j = 0,n2
                     write(ihist2,*) i,j,hist_num3(i,j)
                  enddo
               enddo
            endif

            if ( lradgyr ) rewind(iradg)
            rewind(ihist1)
            if ( lhist_gram ) rewind(ihist3)
            rewind(ihist2)
            write(ifinconf,*) nnstep+nnn 
            do im=1,nbox
               do imolty=1,nmolty
                  write(ifinconf,*) rmtrax(imolty,im), 
     &                rmtray(imolty,im), rmtraz(imolty,im)
                  write(ifinconf,*) rmrotx(imolty,im), rmroty(imolty,im)
     &                , rmrotz(imolty,im)
               enddo
            enddo
            write(ifinconf,*) nchbox(1)
            write(ifinconf,*) nmolty
            write(ifinconf,*) (moltyp(i),i=1,nchbox(1))
                                                                                
            do i = 1, nchbox(1)
               imolty = moltyp(i)
               do j = 1, nunit(imolty)
                  write(ifinconf,*) rxu(i,j),ryu(i,j),rzu(i,j),qqu(i,j)
               enddo
            enddo
            do i = 1,nmolty
               do j = 1,nugrow(i)
                  write(ifinconf,*) rxu_gas(i,j),ryu_gas(i,j),
     &            rzu_gas(i,j)
               enddo
            enddo
            rewind(ifinconf)
         endif

c         do intg = 1, nchbox(1)
c            ibox = nboxi(intg)
c            imolty = moltyp(intg)
c *** accumulate m-n-box and m-s-e-t-e-l ***
c     only count the main chain - not the hydrogens
c            ilunit = nugrow(imolty)
c            setx = rxu(intg,1) - rxu(intg,ilunit)
c            sety = ryu(intg,1) - ryu(intg,ilunit)
c            setz = rzu(intg,1) - rzu(intg,ilunit)
c            setel = setx*setx + sety*sety + setz*setz
c            mnbox( ibox, imolty ) = mnbox( ibox, imolty ) + 1
c            asetel( ibox, imolty ) = asetel( ibox, imolty ) + setel
c         enddo

 100  continue

c *******************************************************************
c ** ends the loop over cycles                                     **
c *******************************************************************

      if ( lradgyr ) write(iradg,*) sumrad(1)/hist_num(1)
      do i = 1,nsum
         if ( hist_num(i) .gt. 0.5d0 ) then
            if (lradgyr) write(iradg,*) sumrad(i)/hist_num(i)
            write(ihist1,*) i,hist_num(i)
         endif
      enddo 
      if ( lhomo ) then
         do i = 0,n1
            do j = 0,n2
               do k = 0,n3
                  jj = (i*(n2+1)+j)*(n3+1)+k
                  if ( hist_num2(jj) .gt. 0.5d0 ) then
                     write(ihist2,'(3i5,f12.0,2f18.6)') i,j,k,
     &                    hist_num2(jj),sumk(jj)/hist_num2(jj),
     &                          sume(jj)/hist_num2(jj)
                  else
                     write(ihist2,'(3i5,3f12.0)') i,j,k,
     &                    hist_num2(jj),0d0,0d0
                  endif
                  if ( lhist_gram ) then
                     jj = (i*(n2+1)+j)*(n3+1)+k
                     do kk = 0,9999
                        if (hist_ene(jj,kk) .gt. 0.5d0 ) then
                           write(ihist3,*) kk, 
     &                          hist_ene(jj,kk)
                        endif 
                     enddo
                     write(ihist3,*) 10000,0d0
                  endif
               enddo
            enddo
         enddo
      else
         do i = 0,n1
            do j = 0,n2
               write(ihist2,*) i,j,hist_num3(i,j)
            enddo
         enddo
      endif

c *** use the following output for debug

      write(22,*) (neigh_cnt(i),i=1,nchbox(1))
      do i = 1,nchbox(1)
         write(22,*) (neighbor(j,i),j=1,neigh_cnt(i))
      enddo

      if (lene_cut) then
         write(42,*) (neigh_cnt2(i),i=1,nchbox(1))
         do i = 1,nchbox(1)
            write(42,*) (neighbor2(j,i),j=1,neigh_cnt2(i))
         enddo
      endif

      write(istdout,*)
      write(istdout,*) '+++++ end of markov chain +++++'
 
c *** write some information about translation/rotation information ***
      write(istdout,*) 
      write(istdout,*) '### Translation ###'
      do i = 1,nmolty
         write(istdout,*) 'molecule typ =',i
         if ( bntrax(i,1) .gt. 0.5d0 ) then
            write(istdout,*) 'attemps = ',bntrax(i,1),'   ratio = ',
     &           bstrax(i,1)/bntrax(i,1)
            write(istdout,*) 'attemps = ',bntray(i,1),'   ratio = ',
     &           bstray(i,1)/bntray(i,1)
            write(istdout,*) 'attemps = ',bntraz(i,1),'   ratio = ',
     &           bstraz(i,1)/bntraz(i,1)
         endif
      enddo

      write(istdout,*) 
      write(istdout,*) '### Rotation ###'
      do i = 1,nmolty
         write(istdout,*) 'molecule typ =',i
         if ( bnrotx(i,1) .gt. 0.5d0 ) then
            write(istdout,*) 'attemps = ',bnrotx(i,1),'ratio = ',
     &           bsrotx(i,1)/bnrotx(i,1)
            write(istdout,*) 'attemps = ',bnroty(i,1),'ratio = ',
     &           bsroty(i,1)/bnroty(i,1)
            write(istdout,*) 'attemps = ',bnrotz(i,1),'ratio = ',
     &           bsrotz(i,1)/bnrotz(i,1)
         endif
      enddo

c *** write some information about config performance ***
      if ( pmcb .gt. 0.0d0 ) then
         write(istdout,*)
         write(istdout,*) '### Configurational-bias ###'
         write(istdout,*)
         do i = 1, nmolty
            write(istdout,*) 'molecule typ =',i
            write(istdout,*) 
     &           '    length  attempts  succ.growth  accepted   ',
     +           '%su.gr.    %accep.'
            do inb = 1, nunit(i)
               if ( bncb(i,inb) .gt. 0.0d0 ) then
                  pscb1 = bscb(i,1,inb) * 100.0d0 / bncb(i,inb)
                  pscb2 = bscb(i,2,inb) * 100.0d0 / bncb(i,inb)
                  write(istdout,'(i9,3f10.1,2f10.2)') inb, bncb(i,inb),
     +                 bscb(i,1,inb), bscb(i,2,inb), pscb1, pscb2
               endif
            enddo
         enddo
         write(istdout,*)
      endif

      write(istdout,*)  
      write(istdout,*) '### Molecule swap       ###'
      write(istdout,*)
      do i = 1, nmolty
         write(istdout,*) 'molecule typ =',i
         do j=1,nswapb(i)
            if ( box1(i,j) .eq. box2(i,j) ) then
               jbox_max = 1
            else
               jbox_max = 2
            endif
            do jbox = 1,jbox_max
               if ( jbox .eq. 1 ) ibox = box1(i,j)
               if ( jbox .eq. 2 ) ibox = box2(i,j)
               write(istdout,66) box1(i,j),box2(i,j),ibox,
     &              bsswap(i,j,ibox),bnswap(i,j,ibox),
     &              bnswap(i,j,ibox+nbox)
               if (bnswap(i,j,ibox) .gt. 0.5d0) then
                  bsswap(i,j,ibox) = bsswap(i,j,ibox+nbox)*
     &                 100.0d0/bsswap(i,j,ibox)
                  bnswap(i,j,ibox) = bnswap(i,j,ibox+nbox)*
     &                 100.0d0/bnswap(i,j,ibox)
                  write(istdout,63) bsswap(i,j,ibox),bnswap(i,j,ibox)
               endif
            enddo
         enddo
      enddo


 61   format(' attempts =',f8.1,'   ratio =',f6.3,
     +      '   max.displ. =',e10.4)
 62   format('between box ',i2,'and ',i2,
     +     ' attempts =',f9.1,'   accepted =',f8.1) 
 63   format(' suc.growth % =',f7.3,'   accepted % =',f7.3)
 65   format(' accepted % =',f7.3)
 66   format('between box ',i2,' and ',i2,' into box',i2,
     +     '   uattempts =',f12.1,' attempts =',f9.1
     &     ,'   accepted =',f8.1)
 67   format(' attempts =',f8.1,'   accepted =',f8.1,
     &     ' accepted % =',f7.3)

 68   format('number of times move in: ', f12.1, 
     &     '  accepted=',f8.1)
 69   format('number of times move out: ', f12.1, 
     &     '  accepted=',f8.1)

c *** checks final value of the potential energy is consistent ***
      
      ibox = 1

      call sumup( ovrlap, v, vinter,vtail,vintra,vvib,
     +     vbend,vtg,vext,velect,vflucq,ibox)
      vend(ibox) = v

c---need to check

      if ( abs(v - vbox(ibox)) .gt. 0.01) then
         write(istdout,*) '### problem with energy ###  box ',ibox
         write(istdout,*) ' Total energy: ',v,vbox(ibox)
      endif
      if ( abs(vinter - vinterb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Inter mol.en.: ',vinter,vinterb(ibox)
      endif
      if ( abs(vtail - vtailb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Tail corr.en.: ',vtail,vtailb(ibox)
      endif
      if ( abs(vintra - vintrab(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Intra mol.en.: ',vintra,vintrab(ibox)
      endif
      if ( abs(vvib - vvibb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' bond vib. en.: ',vvib,vvibb(ibox)
      endif
      if ( abs(vbend - vbendb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Bond ben.en.: ',vbend,vbendb(ibox)
      endif
      if ( abs(vtg - vtgb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Torsion.en.: ',vtg,vtgb(ibox)
      endif
      if ( abs(vext - vextb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Externa.en.: ',vext,vextb(ibox)
      endif
      if ( abs(velect - velectb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Coulomb.en.: ',velect,velectb(ibox)
      endif
      if ( abs(vflucq - vflucqb(ibox)) .gt. 0.001) then
         write(istdout,*) '### problem  ###'
         write(istdout,*) ' Fluc Q en.: ',vflucq,vflucqb(ibox)
      endif

      write(istdout,*)
      write(istdout,1501) (vstart(i) ,i=1,nbox)
      write(istdout,1502) (vend(i)   ,i=1,nbox)
      write(istdout,1504) (vbox(i)   ,i=1,nbox)
 1501 format(' vstart       =',3f24.10)
 1502 format(' vend         =',3f24.10)
 1504 format(' vbox         =',3f24.10)
      write(istdout,*)

      if ( lene_w ) then
         v = 0d0
         do i = 1,nchbox(1)
            v = v + ene1(i)
         enddo
         write(6,*) ' check',v*2d0
         v = 0d0
         do i = 1,nchbox(1)
            v = v + ene2(i)
         enddo
         write(6,*) ' check',v*1.67d5/2d0
      endif

c      if ( lene_w ) then
c         do i = 1,20000
c            write(90+ibox,*) (i-0.5d0)*0.002d0-15d0,hist_ene2(i,ibox)
c            if ( hist_ene2(i) .gt. 0.5d0 ) 
c     &           write(90,*) -(i-0.5d0)*5d0,hist_ene2(i)
c         enddo
c      endif
 
      write(ifinconf,*) nend
      if ( nend .gt. 0 ) then
         do im=1,nbox
            do imolty=1,nmolty
               write(ifinconf,*) rmtrax(imolty,im), rmtray(imolty,im)
     &              , rmtraz(imolty,im)
               write(ifinconf,*) rmrotx(imolty,im), rmroty(imolty,im)
     &              , rmrotz(imolty,im)
            enddo
         enddo

      endif
      write(ifinconf,*) nchbox(1)
      write(ifinconf,*) nmolty
      write(ifinconf,*) (moltyp(i),i=1,nchbox(1))

      do 900 i = 1, nchbox(1)
         imolty = moltyp(i)
         do 899 j = 1, nunit(imolty)
            write(ifinconf,*) rxu(i,j), ryu(i,j), rzu(i,j), qqu(i,j)
 899     continue
 900  continue
      do i = 1,nmolty
         do j = 1,nugrow(i)
            write(ifinconf,*) rxu_gas(i,j),ryu_gas(i,j),
     &            rzu_gas(i,j)
         enddo
      enddo

c	close(8)
      return
      end



