      subroutine readdat(qelect)

      implicit none
 
      include 'control.inc'
      include 'coord.inc'
      include 'coord2.inc'
      include 'cbmc.inc'
      include 'conver.inc'
      include 'system.inc'
      include 'poten.inc'
      include 'connect.inc'
      include 'inputdata.inc'
      include 'qqlist.inc'
      include 'neigh.inc'
      include 'parallel.inc'

      integer temnc, imol, iutemp, imolty, itype,ipair
      integer idummy(ntmax)
      integer i,j,k,ncres, nmtres, iensem, inpbc, nmcount
     &   ,im,nures, ibox, nframe, ij, tcount,ucheck
     &   ,nijspecial,ispecial,jspecial,ji,ii,jj,nexclu,ndum,ntii,
     &     ntjj,jmolty
      integer nhere,zz,temphe,z,itemp,zzz
      integer nvirial
      integer inclnum,inclmol,inclbead,inclsign,ncarbon
      dimension inclmol(ntmax*numax*numax),inclsign(ntmax*numax*numax)
      dimension inclbead(ntmax*numax*numax,2)

      double precision starvir,stepvir,fqtemp,qelect

      double precision pie2,rcnnsq,umatch,aspecd,bspecd,dum
      logical newtab,lnrtab,lucall,lpolar,lqqelect,lee
      logical  linit, lecho, lmixlb, lmixjo, lhere

c      double precision temx,temy,temz
      
      dimension nures(ntmax)
      dimension ncarbon(ntmax)
      dimension lhere(nntype)
      dimension ucheck(ntmax)
      dimension qelect(nntype)
      dimension temphe(nntype)
c      dimension temx(nmax,numax),temy(nmax,numax),temz(nmax,numax)

      double precision vol

c -- reads input data and initializes the positions
c

C --------------------------------------------------------------------
 
c *** set input arrays to zero ***
      do j=1, ntmax
         nugrow(j) = 0
         nunit(j) = 0
         do i=1, numax
            ntype(j,i) = 0
         enddo
      enddo
      do i = 1,nntype**2
         lspecial(i) = .false.
      enddo
      do i = 1, nntype
         lhere(i) = .false.
      enddo

      lee = .false.

c *** read echoing flag
      read(iinpara,*)
      read(iinpara,*) lecho

c - read run information
      read(iinpara,*)
      read(iinpara,*) nstep, lstop, l2d
      if ( lecho ) write(istdout,*) nstep, lstop, l2d
      read(iinpara,*)
      read(iinpara,*) temp, fqtemp
      if ( lecho ) write(istdout,*) temp, fqtemp

C -------------------------------------------------------------------

c *** set up constants and conversion factors ***     
      pie2 = 8.0d0 * datan(1.0d0)
      raddeg = 360.0d0 / pie2
      degrad = pie2 / 360.0d0
      twopi=pie2
      onepi=pie2/2.d00
      
      beta = 1.0d0 / temp
      fqbeta = 1.0d0 / fqtemp
 
C -------------------------------------------------------------------

      read(iinpara,*)
      read(iinpara,*) iprint, imv, iratio, iblock
      if ( lecho ) write(istdout,*) iprint, imv, iratio, iblock

c - read system information

      read(iinpara,*)
      read(iinpara,*) nbox
      if ( lecho ) write(istdout,*) 'number of boxes in the system:',
     &     nbox


      read(iinpara,*)
      read(iinpara,*) nmolty
      if ( nmolty .gt. ntmax ) then
         write(istdout,*) nmolty,ntmax
         stop 'nmolty gt ntmax'
      endif 
      
      read(iinpara,*)
      if ( nmolty .eq. 1 ) then
         read(iinpara,*) n0,n1
         n2 = 0
         n3 = 0
      elseif ( nmolty .eq. 2 ) then
         read(iinpara,*) n0,n1,n2
         n3 = 0
      elseif ( nmolty .eq. 3 ) then
         read(iinpara,*) n0,n1,n2,n3
      endif
      
      nsum = n1+n2+n3
      
      if ( nsum .gt. nmax-2 ) stop 'nchain gt nmax-2'
      if ( lecho ) write(istdout,*) n0,n1,n2,n3, nmolty

      read(iinpara,*)
      read(iinpara,*) lmixlb, lmixjo
      if ( lecho ) write(istdout,*) lmixlb,lmixjo

c --- read special combining rule information
      read(iinpara,*)
      read(iinpara,*) nijspecial
      if (lecho) write(istdout,*) nijspecial
      read(iinpara,*)
      if ( nijspecial .eq. 0 ) then
         read(iinpara,*)
      else
         do i = 1,nijspecial
            read(iinpara,*) ispecial,jspecial,aspecd,bspecd
            ij = (ispecial-1)*nntype + jspecial
            ji = (jspecial-1)*nntype + ispecial
            aspecial(ij) = aspecd
            bspecial(ij) = bspecd
            aspecial(ji) = aspecd
            bspecial(ji) = bspecd
            lspecial(ij) = .true. 
            lspecial(ji) = .true.
            if (lecho) write(istdout,*) ispecial,jspecial,aspecd,bspecd
         enddo
      endif

      read(iinpara,*) 
      read(iinpara,*) rmin, rcut, rcutex, rcutnn, softcut,rcutin
      if ( lecho ) write(istdout,*) rmin, rcut, rcutex, rcutnn, softcut
     &     ,rcutin

      rminsq = rmin*rmin
      rvdwsq = rcut*rcut
      rchgsq = rcut*rcut
      rbcut = rcut

      softlog = 10.0d0**(-softcut)

c - set up the stretching and bending constants
      call suvibe
c - set up the forcefield and the masses
      call suijtab( lmixlb,lmixjo,qelect )      
c - read bead potential information
      do imol = 1, nmolty
         read(iinpara,*) 
         read(iinpara,*) nunit(imol),nugrow(imol),ncarbon(imol)
     &        ,nmaxcbmc(imol), iurot(imol),lelect(imol),B(imol)

         if ( lecho ) write(istdout,*) nunit(imol),nugrow(imol)
     &        ,ncarbon(imol),nmaxcbmc(imol),iurot(imol) ,lelect(imol)

         if ( nunit(imol) .gt. numax ) stop 'nunit gt numax'

         masst(imol) = 0.0d0

         do i = 1, nunit(imol)
c - linear/branched chain with connectivity table -
            read(iinpara,*)
            if ( lelect(imol) .and. .not. lchgall ) then
               read(iinpara,*) j, ntype(imol,i), leaderq(imol,i)
               if ( lecho ) 
     &              write(istdout,*) 'bead ',j,' beadtype ',
     &              ntype(imol,i),' charge leader ',leaderq(imol,i)
               if ( leaderq(imol,i) .gt. j .and. .not. lchgall)
     &              stop 'group-based cut-off screwed for qq'
            else
               read(iinpara,*) j, ntype(imol,i)
               if ( lecho ) 
     &              write(istdout,*) 'bead ',j,' beadtype ',
     &              ntype(imol,i)
            endif
            iutemp = ntype(imol,i)
            masst(imol)=masst(imol)+mass(iutemp)
            lhere(iutemp) = .true.
c - bond vibration -
            read(iinpara,*)
            read(iinpara,*) invib(imol,i)
            if ( invib(imol,i) .gt. 6 ) then
               write(istdout,*) 'imol',imol,'   i',i,'   invib',
     &              invib(imol,i)
               stop 'too many vibrations'
            endif
            do j = 1, invib(imol,i)
               read(iinpara,*) ijvib(imol,i,j),itvib(imol,i,j)
            enddo
c - bond bending -
            read(iinpara,*)
            read(iinpara,*) inben(imol,i)
            if ( inben(imol,i) .gt. 12 ) stop 'too many bends'
            do j = 1, inben(imol,i)
               read(iinpara,*) ijben2(imol,i,j),ijben3(imol,i,j)
     &              ,itben(imol,i,j)
            enddo
c - bond torsion -
            read(iinpara,*)
            read(iinpara,*) intor(imol,i)
            if ( intor(imol,i) .gt. 10 ) stop 'too many torsions'
            do j = 1, intor(imol,i)
               read(iinpara,*) ijtor2(imol,i,j),ijtor3(imol,i,j),
     &              ijtor4(imol,i,j),ittor(imol,i,j)
            enddo
         enddo

         read(iinpara,*)
         read(iinpara,*) (pmbsmt(imol,ii),ii=1,nmolty)
         if ( lecho ) then
            write(istdout,*) 
     &           'Bias for cluster formation and destruction'
            write(istdout,*) (pmbsmt(imol,ii),ii=1,nmolty)
         endif
         read(iinpara,*)
         read(iinpara,*) rbmax(imol),rbmin(imol)
         if ( lecho ) write(istdout,*) rbmax(imol),rbmin(imol)
         if (rbmax(imol) .lt. rbmin(imol))
     &        stop 'rbsmax should be greater than rbsmin'
      enddo
      do i = 1,nmolty
         do j = 1,nmolty
            rbsmaxsq(i,j) = (rbmax(i)+rbmax(j))**2
            rbsminsq(i,j) = (rbmin(i)+rbmin(j))**2
         enddo
      enddo

c -- check whether there is a polarizable molecule

      lqqelect = .false.
      do imol = 1, nmolty
         if (lelect(imol)) lqqelect = .true.
      enddo

c - read displacement information
      read(iinpara,*) 
      read(iinpara,*) rmtrax(1,1),rmtray(1,1),rmtraz(1,1)
      do im = 1,nbox
         do imol = 1,nmolty
            rmtrax(imol,im) = rmtrax(1,1)
            rmtray(imol,im) = rmtray(1,1)
            rmtraz(imol,im) = rmtraz(1,1)
         enddo
      enddo
      if ( lecho ) write(istdout,*) rmtrax(1,1),rmtray(1,1),rmtraz(1,1)
      read(iinpara,*) 
      read(iinpara,*) rmrotx(1,1),rmroty(1,1),rmrotz(1,1)
      do im = 1,nbox
         do imol = 1,nmolty
            rmrotx(imol,im) = rmrotx(1,1)
            rmroty(imol,im) = rmroty(1,1)
            rmrotz(imol,im) = rmrotz(1,1)
         enddo
      enddo
      if ( lecho ) write(istdout,*) rmrotx(1,1),rmroty(1,1),rmrotz(1,1)
 
c --- read swap info
      read(iinpara,*)
      read(iinpara,*) pmswap, (pmswmt(i),i=1,nmolty)
      if ( lecho ) write(istdout,*) 'pmswap',pmswap,pmswmt
      do i = 1, nmolty
         read(iinpara,*)
         read(iinpara,*) nswapb(i), (pmswapb(i,ipair),ipair=1,nswapb(i))
         if ( lecho ) write(istdout,*) nswapb(i), 
     &                (pmswapb(i,ipair),ipair=1,nswapb(i))
         read(iinpara,*)
         do ipair = 1, nswapb(i)
            read(iinpara,*) box1(i,ipair), box2(i,ipair)
            if ( lecho ) write(istdout,*) 'box pair:',
     &                   box1(i,ipair), box2(i,ipair)
         enddo
      enddo
c --- read cbmc info
      read(iinpara,*)
      read(iinpara,*) pmcb, (pmcbmt(i),i=1,nmolty)
      read(iinpara,*)
      read(iinpara,*) (pmall(i),i=1,nmolty)
      if ( lecho ) write(istdout,*) 'pmcb',pmcb,pmcbmt,pmall
c --- read translation info
      read(iinpara,*)
      read(iinpara,*) pmtra,(pmtrmt(i),i=1,nmolty)
      if ( lecho ) write(istdout,*) 'pmtra',pmtra,pmtrmt
c --- read rotation info
      read(iinpara,*)
      read(iinpara,*) (pmromt(i),i=1,nmolty)
      if ( lecho ) write(istdout,*) pmromt
c --- read growth details
      read(iinpara,*)
      read(iinpara,*) (nchoi1(i),i=1,nmolty),(nchoi(i),i=1,nmolty)
     &     ,(nchtor(i),i=1,nmolty)
      if ( lecho ) then
         write(istdout,*) 'nchoi1',(nchoi1(i),i=1,nmolty)
         write(istdout,*) 'nchoi',(nchoi(i),i=1,nmolty)
         write(istdout,*) 'nchtor',(nchtor(i),i=1,nmolty)
      endif

c     --- read information for CBMC bond angle growth
      read(iinpara,*) 
      read(iinpara,*) (nchbna(i),i=1,nmolty),(nchbnb(i),i=1,nmolty)
      if ( lecho ) then
         write(istdout,*) 'nchbna ',(nchbna(i),i=1,nmolty)
         write(istdout,*) 'nchbnb ',(nchbnb(i),i=1,nmolty)
      endif

      read(iinpara,*)
      read(iinpara,*) (icbdir(i),i=1,nmolty),(icbsta(i),i=1,nmolty)
      if ( lecho ) then 
         write(istdout,*) 'icbdir',(icbdir(i),i=1,nmolty)
         write(istdout,*) 'icbsta',(icbsta(i),i=1,nmolty)
      endif

c     ---- Error checking
      do i=1,nmolty
         if ( nchoi1(i) .gt. nchmax ) stop 'nchoi1 gt nchmax'
         if (nchoi(i) .gt. nchmax ) stop 'nchoi gt nchmax'
         if ( nchtor(i) .gt. nchtor_max ) 
     &        stop 'nchtor gt nchtor_max'
         if ( nchbna(i) .gt. nchbn_max ) 
     &        stop 'nchbna gt nchbn_max'
         if ( nchbnb(i) .gt. nchbn_max ) 
     &        stop 'nchbnb gt nchbn_max'
         if ( icbsta(i) .gt. numax ) stop 'icbsta gt numax'
      enddo

c --- read exclusion table for intermolecular interactions
      read(iinpara,*)
      read(iinpara,*) nexclu
      do i = 1, nmolty
         do ii = 1, nunit(i)
            do j = 1, nmolty
               do jj = 1, nunit(j)
                  ntii = ntype(i,ii)
                  ntjj = ntype(j,jj)
                  if ( (.not. (lij(ntii) .and. lij(ntjj))) .and.
     &                 (.not. (lqchg(ntii) .and. lqchg(ntjj)))
     &                 .and. (lchgall .or. ii .ne. leaderq(i,ii)
     &                 .or. jj .ne. leaderq(j,jj) ) ) then
                     lexclu(i,ii,j,jj) = .true.
                  else 
                     lexclu(i,ii,j,jj) = .false.
                  endif
               enddo
            enddo
         enddo
      enddo       
      if ( lecho ) write(istdout,*) nexclu
      if (nexclu .ne. 0) then
         do ndum = 1, nexclu
            read(iinpara,*) i, ii, j, jj
            lexclu(i,ii,j,jj) = .true.
            lexclu(j,jj,i,ii) = .true.
         enddo
      else
         read(iinpara,*)
      endif

c --- read inclusion list 
      read(iinpara,*)
      read(iinpara,*) inclnum
      if ( lecho ) write(istdout,*) inclnum
      if (inclnum .ne. 0) then
         do ndum = 1, inclnum
            read(iinpara,*) inclmol(ndum),inclbead(ndum,1),
     &           inclbead(ndum,2),inclsign(ndum)
            if (lecho ) then
               write(istdout,*) inclmol(ndum),inclbead(ndum,1)
     &              ,inclbead(ndum,2),inclsign(ndum)
            endif
         enddo
      else
         read(iinpara,*)
      endif

c - set up the inclusion table
      call inclus( inclnum,inclmol,inclbead,inclsign,ncarbon)

      read(iinpara,*) 
      read(iinpara,*) lene_cut,lene_w,lmisc,lhomo,lhist_gram
      if ( lecho ) write(istdout,*) lene_cut,lene_w,lmisc,
     &     lhomo,lhist_gram
      if ( lcluster1 .or. lcluster2 ) then
         if ( lmisc ) then
            read(ibias,*) j
            if ( j .ne. 0 ) then
               do i = 1,nsum
c                  if ( lhomo ) then
c                     read(ibias,*) j,(fbias(j,imol),imol=1,nmolty)
c                  else
                     read(ibias,*) fbias(i)
c                  endif
                     write(63,*) i,fbias(i)
               enddo
            else
               do i = 1,nsum
c                  do imol = 1,nmolty
                     fbias(i) = 0d0
c                  enddo
               enddo
            endif
         else
            if ( nnmax .lt. (n1+1)*(n2+1)*(n3+1) ) then
               stop 'nnmax too small in control.inc'
            endif

            read(ibias,*) j
            if ( j .ne. 0 ) then
               do i = 0,n1
                  do j = 0,n2
                     do k = 0,n3
                        ii = (i*(n2+1)+j)*(n3+1)+k
                        read(ibias,*) fbias(ii)
                        write(16,*) i,j,k,fbias(ii)
                     enddo
                  enddo
               enddo
            else
               do i = 0,n1
                  do j = 0,n2
                     do k = 0,n3
                        ii = (i*(n2+1)+j)*(n3+1)+k
                        fbias(ii) = 0d0
                     enddo
                  enddo
               enddo
            endif
         endif
                                                                                  
      endif

      if (lecho) write(istdout,*) 'Energy cutoff for cluster?',lene_cut
      if ( lene_cut ) then
         read(iinpara,*)
         read(iinpara,*) ((ene_cut(i,j),i=1,nmolty),j=1,nmolty)
         if (lecho) write(istdout,*) 'ene_cut:',
     &        ((ene_cut(i,j),i=1,nmolty),j=1,nmolty)
      endif

      read(iinpara,*)
      read(iinpara,*) lradgyr
      if (lecho) write(istdout,*) 'Calculating radgyr?',lradgyr

C -------------------------------------------------------------------
 
c *** restart saver
      if ( nstep .gt. 100 ) then
         irsave = nstep / 10
      else
         irsave = nstep + 1
      endif

c -------------------------------------------------------------------
 
c * check information of .INC-files 
      write(istdout,*) '***** program   =  THE MAGIC BLACK BOX'

      if ( lcluster1 ) then
         iensem = iensem + 1
         write(istdout,*) 'conventional grand-canonical ensemble'
     &        ,' for cluster nucleation'
      endif
      if ( lcluster2 ) then
         iensem = iensem + 1
         write(istdout,*) 'advanced grand-canonical ensemble'
     &        ,' for cluster nucleation combined with AVBMC'
      endif

      if ( lijall ) then
         write(istdout,*) 'all i-j-interactions are considered',
     &        '  (no potential cut-off)'
      endif

      if ( lchgall ) then
         write(istdout,*) 
     &        'all the intermolecular Coulombic interactions',
     &        ' are considered (no group-based cutoff)'
      endif
      if ( lcutcm ) then
         write(istdout,*) 'additional (COM) cutoff on computed rcmu'
         if ( lijall ) stop 'cannon have lijall with lcutcm'
c         if ( lchgall ) stop 'cannot have lchgall with lcutcm'
      endif
      if ( ldual ) then
         write(istdout,*) 
     &        'Dual Cutoff Configurational-bias Monte Carlo'
      endif

      write(istdout,*) 
     & 'CBMC simultaneously grows all beads conected to the same bead'
      write(istdout,*) 
     &     'with bond angles generated from Gaussian distribution'

      write(istdout,*) 'Lennard-Jones potential for bead-bead'

      if ( ltailc ) then
         write(istdout,*) 'with additional tail corrections'
	 if (lshift) stop ' lshift.and.ltailc!'
      endif

      if ( lshift) then
         write(istdout,*) 'using a shifted potential'
	 if (ltailc) stop ' lshift.and.ltailc!'
      endif
         
      write(istdout,*) 
     &     'Coulombic inter(but not intra)molec interactions'

      write(istdout,*)
      write(istdout,*) 'MOLECULAR MASS:', (masst(i),i=1,nmolty)

C -------------------------------------------------------------------

c *** read/produce initial/starting configuration ***

C ----------------------------------------------------------------
      read(iinconf,*) nnstep
      do im = 1,nbox
         do imol = 1,nmolty
            read(iinconf,*) rmtrax(imol,im), rmtray(imol,im)
     &           , rmtraz(imol,im)
            read(iinconf,*) rmrotx(imol,im), rmroty(imol,im)
     &           , rmrotz(imol,im)
         enddo
      enddo
      write(istdout,*) 
     +     'new maximum displacements read from restart-file'
      do im = 1,nbox
         write(istdout,*)'box      #',im
         do imol = 1,nmolty
            write(istdout,*) 'molecule type',imol
            write(istdout,1101) rmtrax(imol,im), rmtray(imol,im)
     &           , rmtraz(imol,im)
            write(istdout,1102) rmrotx(imol,im), rmroty(imol,im)
     &           , rmrotz(imol,im)
         enddo
      enddo

      write(istdout,*)

      read(iinconf,*) nchbox(1)
      read(iinconf,*) nmtres
c --- check that number of particles in fort.4 & fort.77 agree ---
      if ( nmtres .ne. nmolty ) then
         write(istdout,*)
     +         'conflicting information in restart and control files'
         write(istdout,*) 'nmolty',nmolty,'nmtres',nmtres
         stop
      endif
      do i = 1,nchbox(1)
         nboxi(i) = 1
      enddo

      read(iinconf,*) (moltyp(i),i=1,nchbox(1))

      do i = 1, nchbox(1)
         imolty = moltyp(i)
         do j = 1,nunit(imolty)
            read(iinconf,*) rxu(i,j),ryu(i,j),rzu(i,j),qqu(i,j)
         enddo
      enddo

c--- book keeping arrays
      do i = 1,nmolty
         do j = 1,nugrow(i)
            read(iinconf,*) rxu_gas(i,j),ryu_gas(i,j),rzu_gas(i,j)
         enddo
         do ibox = 1,nbox
            ncmt(ibox,i) = 0
         enddo
      enddo
      do i = 1, nchbox(1)
         imolty = moltyp(i)
         ncmt(1,imolty) = ncmt(1,imolty)+1
      enddo
      do imolty = 1,nmolty
         if ( imolty .eq. 1 ) then
            i = n1
         elseif ( imolty .eq. 2 ) then
            i = n2
         else
            i = n3
         endif 
         if ( ncmt(1,imolty) .gt. i ) then
         write(6,*) 'The maximum number of molecules exceeded for type'
     &              ,imolty
         stop
         endif
      enddo


      do ibox=1,nbox
         do imolty=1,nmolty
            idummy(imolty)=0
         enddo      
         j = 0
         do i = 1, nchbox(1)
            imolty=moltyp(i)
            idummy(imolty) = idummy(imolty)+1
            parbox(idummy(imolty),ibox,imolty)=i
            parpt(i) = idummy(imolty)
         enddo
      enddo

c     set idummy counter to 0
      do imolty=1,nmolty
         idummy(imolty)=0
      enddo
c     set up parall
      do i =1,nchbox(1)
         imolty = moltyp(i)
         idummy(imolty) = idummy(imolty) + 1
         parall(imolty,idummy(imolty)) = i
      enddo
C -------------------------------------------------------------------
 
      do ibox = 1, nbox
         call ctrmas(.true.,ibox,0,6)
      enddo

      if ( lradgyr ) then
         xclust = 0d0
         yclust = 0d0
         zclust = 0d0
         do i = 1,nchbox(1)
            if ( nboxi(i) .eq. 1 ) then
               xclust = xclust + xcm(i)
               yclust = yclust + ycm(i)
               zclust = zclust + zcm(i)
            endif
         enddo
         xclust = xclust/nchbox(1)
         yclust = yclust/nchbox(1)
         zclust = zclust/nchbox(1)
      endif


c * calculate number of frames *
      nframe = nstep / imv
 
c *** write out movie-header ***
      if ( nframe .ne. 0 ) then
         write(imovie) nframe,nchbox(1),nmolty
         nhere = 0
         do zz=1,nntype
            if ( lhere(zz) ) then
               nhere = nhere + 1
               temphe(nhere) = zz
            endif
         enddo
         write(imovie) nhere,(temphe(zz),zz=1,nhere)
         
         do imolty = 1,nmolty
            write(imovie) nunit(imolty)
c     output bond connectivity information
            do ii=1,nunit(imolty)
               write(imovie) invib(imolty,ii)
     &              ,(ijvib(imolty,ii,z),z=1,invib(imolty,ii))
            enddo

c     output torsional connectivity information
            do j = 1,nunit(imolty)
               write(imovie) intor(imolty,j)
               do ii = 1,intor(imolty,j)
                  write(imovie) ijtor2(imolty,j,ii)
     &                 ,ijtor3(imolty,j,ii),ijtor4(imolty,j,ii)
               enddo
            enddo
         enddo
      endif

 
C ---------------------------------------------------------------
 
      write(istdout,*)
      write(istdout,*) 
     &  '    i  j    sig2ij     epsij         q0(i)          q0(j)'
      do i = 1, nntype
         do j = 1,nntype
            if ( lhere(i) .and. lhere(j) ) then
               ij = (i-1)*nntype + j
               write(istdout,'(3x,2i3,2f10.5,2f15.6)') i,j
     &              ,dsqrt(sig2ij(ij))
     &              , epsij(ij),qelect(i),qelect(j)
            endif
         enddo
      enddo

c *** write input data to unit 6 for control ***
      write(istdout,*)
      write(istdout,*) 'number of mc cycles:            ', nstep
      write(istdout,*) 'number of chains:               ', nchbox(1)
      write(istdout,*)
      write(istdout,*) 'temperature:                    ', temp
      write(istdout,*)
      write(istdout,*) 'ex-pressure:                    ', express
      write(istdout,*)


C -------------------------------------------------------------------
  
 1012 format(3(1x,f10.6),2i5)
      
 1101 format(' max trans. displacement:        ',3f10.6)
 1102 format(' max rot. displacement:          ',3f10.6)
 1103 format(' max volume displacement:        ',3e12.4)
 1104 format(' dimension box ',i1,':                ',3e12.5)
 1105 format(' angle of  box ',i1,':                ',3f12.6)
      return
      end





