      subroutine suijtab( lmixlb,lmixjo,qelect )

      implicit none

      include 'control.inc'
      include 'coord.inc'
      include 'external.inc'
      include 'poten.inc'
      include 'system.inc'
      include 'parallel.inc'

      logical lmixlb, lmixjo

      integer i, j, ij, ji
      double precision  qelect(nntype)

      double precision rcheck, sr2, sr6, adum, bdum, rs1, rs7, sr7,
     +     pi,djay

c ----------------------------------------------------------------
 
      pi = 4.0d0*datan(1.0d0)

      do i = 1, nntype
         sigi(i) = 0.0d0
         epsi(i) = 0.0d0
         mass(i) = 0.0d0
         qelect(i) = 0.0d0
         xiq(i) = 0.0d0
         lqchg(i) = .false.
         lij(i) = .true.
         lhard(i) = .false.
      enddo

C --- STANDARD S-K-S Nature METHYL GROUP
      sigi(1) = 1.0d0
      epsi(1) = 1.0d0
      mass(1) = 1.0d0
c      sigi(1) = (1.0d0/0.35d0)**(1.0d0/6.0d0)
c      epsi(1) = 0.35d0*0.35d0 
c      mass(1) = 1.0d0
c      sigi(1) = 3.93d0
c      epsi(1) = 114.0d0
c      mass(1) = 15.0347d0
c      sigi(1) = 3.405d0
c      epsi(1) = 119.8d0
c      mass(1) = 39.948d0

C --- TRAPPE METHYLENE GROUP
      sigi(2) = 3.95d0
      epsi(2) = 46.0d0
c      sigi(2) = 3.85d0
c      epsi(2) = 60.0d0
      mass(2) = 14.0268d0

C --- ETHYL-BRANCH METHYL GROUP Mol. Phys. no tail correction
      sigi(3) = 3.93d0
      epsi(3) = 95.0d0
      mass(3) = 15.0347d0

C --- METHYL-BRANCH METHYL GROUP Mol. Phys. no tail correction
      sigi(4) = 3.93d0
      epsi(4) = 78.0d0
      mass(4) = 15.0347d0

C --- STANDARD TERTIARY CARBON GROUP OPLS Jorgensen 
      sigi(5) = 3.85d0
      epsi(5) = 32.0d0
      mass(5) = 13.0191d0

C --- STANDARD QUATERNARY CARBON GROUP OPLS Jorgensen
      sigi(6) = 3.85d0
      epsi(6) = 25.0d0
      mass(6) = 12.0113d0

C --- TraPPE (ilja email 4-14-99) CF3 GROUP
      sigi(7) = 4.36d0
      epsi(7) = 87.0d0
      mass(7) = 69.0065d0

C --- TraPPE (ilja email 4-14-99) CF2 GROUP
      sigi(8) = 4.73d0
      epsi(8) = 27.5d0
      mass(8) = 50.0081d0

C --- Carbon in Carbon Monoxide
      sigi(9) = 3.75d0
      epsi(9) = 52.9d0
      mass(9) = 12.011d0
      qelect(9) = -0.019d0

C --- Oxygen in Carbon Monoxide
      sigi(10) = 2.96d0
      epsi(10) = 105.7d0
      mass(10) = 15.999d0
      qelect(10) = 0.019d0

C --- Krypton  
      sigi(11) = 3.607d0
      epsi(11) = 161.0d0
      mass(11) = 83.80d0

C --- Argon TraPPE (7-18-97 MGM)
      sigi(12) = 3.390d0
      epsi(12) = 116.0d0
      mass(12) = 39.948d0

C --- Helium TraPPE (7-18-97 MGM)
      sigi(13) = 3.11d0
      epsi(13) = 4.0d0
c      sigi(13) = 3.065d0 used in JACS paper 1997
c      epsi(13) = 3.95d0
      mass(13) = 4.0026d0
c      sigi(13) = 2.556d0
c      epsi(13) = 10.2d0
c      mass(13) = 4.00d0
C --- Lennard-Jonesium ETHANE
      sigi(14) = 4.25d0
      epsi(14) = 236.0d0
      mass(14) = 30.070d0

C --- Lennard-Jonesium HEPTANE
      sigi(15) = 6.08d0
      epsi(15) = 418.0d0
      mass(15) = 100.203d0

C --- Marcus Quaternary Carbon Try b - TraPPE 4-16-98 [C]
c      sigi(16) = 6.3d0
      epsi(16) = 0.5d0
c      mass(16) = 12.011d0
c ** from Bin 6-20-00 (alcoholic)
      sigi(16) = 5.8d0
      qelect(16) = 0.265d0
      lqchg(16) = .true.
      mass(16) = 12.011d0
c *** for MTBE ***
c      sigi(16) = 5.8d0
c      qelect(16) = 0.25d0
c      lqchg(16) = .true.

C --- Mol. Phys. Methyl [CH3] sp3
      sigi(17) = 3.77d0
      epsi(17) = 98.1d0
      mass(17) = 15.0347d0

C --- Jorgensen's OPLS sp2 CH2 group JACS 106, 6638-6646 (1984)
      sigi(18) = 3.85d0
      epsi(18) = 70.43d0
      mass(18) = 14.0269d0

C --- Jorgensen's sp2 hybrid CH group JACS 106, 6638-6646 (1984)
      sigi(19) = 3.800d0
      epsi(19) = 57.85d0
      mass(19) = 13.0191d0

c --- perflouromethane (CF4)
c      sigi(20) = 4.13d0
c      epsi(20) = 172.95d0
c      sigi(20) = 4.18d0 (fit for critical density)
c     --- Bin's Parameters 
c      sigi(20) = 4.15d0
c      epsi(20) = 175.4d0
      sigi(20) = 3.75d0
      epsi(20) = 98d0
      mass(20) = 88.003d0

c --- explicit atom C methyl tildesly
      sigi(21) = 3.367d0
      epsi(21) = 48.8d0
      mass(21) = 12.011d0

c --- explicit atom C methylene tildesly
      sigi(22) = 3.367d0
      epsi(22) = 48.8d0
      mass(22) = 12.011d0

c --- explicit atom H tildesly
      sigi(23) = 2.908d0
      epsi(23) = 6.84d0
      mass(23) = 1.0079d0

C --- TraPPE Methyl (J. Phys. Chem.) [CH3] sp3
      sigi(24) = 3.75d0
      epsi(24) = 98.0d0
      mass(24) = 15.0347d0
c *** adding ether charge
c      sigi(24) = 3.75d0
c      epsi(24) = 98.0d0
c      mass(24) = 15.0347d0
c      qelect(24) = 0.25d0
c      lqchg(24) = .true.

c --- United Atom TraPPE TERTIARY (Methine) Carbon Group [CH] sp3
c      sigi(25) = 4.68d0
      sigi(25) = 4.33d0
      epsi(25) = 10.0d0
      mass(25) = 13.0191d0

c --- united atom  TraPPE (similar to OPLS) Methane [CH4] sp3
      sigi(26) = 3.73d0
      epsi(26) = 148d0
      mass(26) = 16.043d0
c --- LJ + qq + polarizability 
c      qelect(26) = -0.572d0
c      lqchg(26) = .true.
c      jayself(26) = 0.5d0*117403d0
c      xiq(26) = 9449.3d0

c --- united atom OPLS Methyl ethane [CH3] sp3
      sigi(27) = 3.775d0
      epsi(27) = 104.1d0
      mass(27) = 15.0347d0

c --- united atom OPLS Methylene [CH2] sp3
      sigi(28) = 3.905d0
      epsi(28) = 59.4d0
      mass(28) = 14.0268d0

c --- united atom OPLS Methyl butane [CH3] sp3
      sigi(29) = 3.905d0
      epsi(29) = 88.1d0
      mass(29) = 15.0347d0

C --- MolPhys TERTIARY (Methine) CARBON GROUP [CH] sp3
      sigi(30) = 4.10d0
      epsi(30) = 12.0d0
      mass(30) = 13.0191d0

c --- Charmm C2 (methylene group carbon)
      sigi(31) = 3.8754d0
      epsi(31) = 19.6257d0
      mass(31) = 0.003d0

c --- Charmm H (hydrogen)
      sigi(32) = 2.4500d0
      epsi(32) = 19.1225d0
      mass(32) = 1.0078d0

c --- Charmm O (bound with 2 single bonds)
      sigi(33) = 2.8598d0
      epsi(33) = 114.7348d0
      mass(33) = 16.00d0

c --- Charmm P
      sigi(34) = 3.7418d0
      epsi(34) = 100.6446d0
      mass(34) = 0.003d0

c --- Charmm O' (bound with a double bond)
      sigi(35) = 2.8598d0
      epsi(35) = 114.7348d0
      mass(35) = 16.00d0

c --- Charmm N3 (tertiary ammonia)
      sigi(36) = 3.5012d0
      epsi(36) = 84.0382d0
      mass(36) = 0.003d0

c --- Charmm C3 (methyl group carbon)
      sigi(37) = 3.8754d0
      epsi(37) = 19.6257d0
      mass(37) = 0.003d0

c --- Charmm C1 (ternary carbon)
      sigi(38) = 3.8754d0
      epsi(38) = 19.6257d0
      mass(38) = 0.003d0

c --- Charmm C' (carboxylic head group carbon)
      sigi(39) = 3.6170d0
      epsi(39) = 74.4770d0
      mass(39) = 0.003d0

c --- SPC/E O (simple point charge water oxygen)
c      sigi(40) = 3.1655d0
c      epsi(40) = 78.1958d0
      mass(40) = 16.000d0
c      qelect(40) = -0.8476d0
c --- TIP3P
c      sigi(40) = 3.150574227d0
c      epsi(40) = 76.54020157d0
      sigi(40) = 3.15061d0
      epsi(40) = 76.54020157d0
c --- SPC
c      sigi(40) = 3.167d0
c      epsi(40) = 0.6517d0*503.25d0/4.184d0
      qelect(40) = -0.834d0
      lqchg(40) = .true.

c --- OPLS-UA 1990 charged methyl  [CH3]
      sigi(41) = 3.91d0
      epsi(41) = 80.6d0
      mass(41) = 15.0347d0
      qelect(41) = 0.080d0
      lqchg(41) = .true.

c --- OPLS-UA 1990 carbonyl carbon  -[C]OOH
      sigi(42) = 3.75d0
      epsi(42) = 52.9d0
      mass(42) = 12.011d0
      qelect(42) = 0.55d0
      lqchg(42) = .true.

c --- OPLS-UA 1990 carboxyllic acid OH Oxygen  -[O]-H
      sigi(43) = 3.0d0
      epsi(43) = 85.6d0
      mass(43) = 15.999d0
      qelect(43) = -0.58d0
      lqchg(43) = .true.

c --- OPLS-UA 1990 and OPLS-AA 1995 carboxyllic acid OH Hydrogen O-[H]
      sigi(44) = 0.0d0
      epsi(44) = 0.0d0
      mass(44) = 1.0079d0
      qelect(44) = 0.45d0
      lij(44) = .false.
      lqchg(44) = .true.

c --- OPLS-UA 1990 carbonyl Oxygen  C[=O]
      sigi(45) = 2.96d0
      epsi(45) = 105.7d0
      mass(45) = 15.999d0
      qelect(45) = -0.5d0
      lqchg(45) = .true.

c --- OPLS-AA 1995 carbonyl Oxygen  C[=O]
      sigi(46) = 2.96d0
      epsi(46) = 105.8d0
      mass(46) = 15.999d0
      qelect(46) = -0.440d0
      lqchg(46) = .true.

c --- OPLS-AA 1995 carboxylic acid Oxygen C-[O]-H
      sigi(47) = 3.00d0
      epsi(47) = 85.7d0
      mass(47) = 15.999d0
      qelect(47) = -0.53d0
      lqchg(47) = .true.

c --- OPLS-AA 1995 carbonyl carbon  -[C]OOH
      sigi(48) = 3.75d0
      epsi(48) = 52.9d0
      mass(48) = 12.011d0
      qelect(48) = 0.51d0
      lqchg(48) = .true.

c --- TraPPE-UA carbonyl acid hydrogen C-O-[H]
      sigi(49) = 0.0d0
      epsi(49) = 0.0d0
      mass(49) = 1.0078d0
      qelect(49) = 0.30
      lij(49) = .false.
      lqchg(49) = .true.

c --- SPC/E H (simple point charge Enhanced water hydrogen)
      sigi(50) = 0.0d0
      epsi(50) = 0.0d0
      mass(50) = 1.0078d0
c      qelect(50) = 0.4238d0      
c --- TIP3P
c      sigi(50) = 0.4000135244d0
c      epsi(50) = 23.14825294d0
      qelect(50) = 0.417d0
      lij(50) = .false.
      lqchg(50) = .true.

c --- Methanol and alkanol H (van Leeuwen JPC 99, 1831 (1995))
      sigi(51) = 0.0d0
      epsi(51) = 0.0d0
      mass(51) = 1.0078d0
      qelect(51) = 0.435d0
      lqchg(51) = .true.
c * Methanol H from H2 parameter set from Monica's dissertation *
c      sigi(51) = 0.d0
c      epsi(51) = 0.d0
c      mass(51) = 1.0078d0
c      qelect(51) = 0.432d0
c      lqchg(51) = .true.

c --- Methanol and alkanol O (van Leeuwen JPC 99, 1831 (1995))
c      sigi(52) = 3.03d0
c      epsi(52) = 86.5d0
c * Methanol O from H2 parameter set from Monica's dissertation *
c      sigi(52) = 3.069d0
c      epsi(52) = 113.d0
c      mass(52) = 16.00d0
c      qelect(52) = -0.660d0
c      lqchg(52) = .true.

c - TraPPE trial
      sigi(52) = 3.02d0
      epsi(52) = 93.0d0
      mass(52) = 16.00d0
      qelect(52) = -0.700d0
      lqchg(52) = .true.

c --- Methanol CH_3 (van Leeuwen JPC 99, 1831 (1995))
c      sigi(53) = 3.74d0
c      epsi(53) = 105.2d0
c * Methanol CH_3 from H2 parameter set from Monica's dissertation *
c      sigi(53) = 3.931d0
c      epsi(53) = 15.d0
c      mass(53) = 15.0347d0
c      qelect(53) = 0.228d0
c      lqchg(53) = .true.

c - TraPPE
      sigi(53) = sigi(24)
      epsi(53) = epsi(24)
      mass(53) = 15.0347d0
      qelect(53) = 0.265d0
      lqchg(53) = .true.
c *** TraPPE methyl group for CH_3-(O)-(R) ***
c      sigi(53) = sigi(24)
c      epsi(53) = epsi(24)
c      mass(53) = 15.0347d0
c      qelect(53) = 0.25d0
c      lqchg(53) = .true.

c --- Alkanol (O)-CH_2-(CH_x) (van Leeuwen JPC 99, 1831 (1995))
c      sigi(54) = 3.74d0
c      epsi(54) = 47.0d0
c - TraPPE
      sigi(54) = sigi(2)
      epsi(54) = epsi(2)
      mass(54) = 14.0268d0
      qelect(54) = 0.265d0
      lqchg(54) = .true.

C- Dummy methylene for Sciece Paper MGM 12-17-97
c      sigi(55) = 3.95d0
c      epsi(55) = 55.0d0
c      mass(55) = 14.0268d0
c - TraPPE methine group in alkanol
      sigi(55) = sigi(25)
      epsi(55) = epsi(25)
      mass(55) = mass(25)
      qelect(55) = 0.265d0
      lqchg(55) = .true.

c --- TraPPE iterB carbonyl Oxygen  C[=O]
c      sigi(56) = 3.0d0
c      epsi(56) = 75.0d0
c      qelect(56) = -0.440d0
      sigi(56) = 3.04d0
      epsi(56) = 81.0d0
      qelect(56) = -0.424d0
      mass(56) = 15.999d0
      lqchg(56) = .true.

c --- TraPPE iterB carboxylic acid Oxygen C-[O]-H
c      sigi(57) = 3.00d0
c      epsi(57) = 75.0d0
c      qelect(57) = -0.53d0
      sigi(57) = 3.02d0
      epsi(57) = 93.0d0
      qelect(57) = -0.30d0
      mass(57) = 15.999d0
      lqchg(57) = .true.

c --- TraPPE iterB carbonyl carbon  -[C]OOH
c      sigi(58) = 4.0d0
c      epsi(58) = 42.0d0
c      qelect(58) = 0.52d0
      sigi(58) = 3.60d0
      epsi(58) = 65.0d0
      qelect(58) = 0.424d0
      mass(58) = 12.011d0
      lqchg(58) = .true.

c --- CF3 methyl group
c     iterb
      sigi(59) = 4.35d0
      epsi(59) = 87.0d0
      mass(59) = 69.006d0

c --- Amber AA for CF4 carbon (C) (JCC 13(1992) P963) ---
c      sigi(60) = 3.82d0/(2.0d0**(1.0d0/6.0d0))
c      epsi(60) = 55.05d0
c      mass(60) = 12.011d0
c      qelect(60) = -0.756d0
c      lqchg(60) = .true.

c --- Amber AA for CF4 flurine (F) (JCC 13(1992) P963) ---
c      sigi(61) = 3.50d0/(2.0d0**(1.0d0/6.0d0))
c      epsi(61) = 30.70d0
c      mass(61) = 18.9984d0
c      qelect(61) = 0.189d0
c      lqchg(61) = .true.

c --- AA for alkane methane (CH4) carbon
      sigi(60) = 3.3d0
      epsi(60) = 0.01d0
      mass(60) = 12.011d0

c --- AA for alkane methine (CH) carbon
      sigi(61) = 4.0d0
      epsi(61) = 2.0d0
      mass(61) = 12.011d0

c --- AA for alkane methylene (CH2) carbon ---
      sigi(62) = 3.65d0
      epsi(62) = 5.0d0
      mass(62) = 12.011d0
c --- LJ + qq + polarizability for methane hydrogen
c      sigi(62) = 0.0d0
c      epsi(62) = 0.0d0
c      qelect(62) = 0.143d0
c      lqchg(62) = .true.
c      lij(62) = .false.
c      xiq(62) = 0.0d0
c      jayself(62) = 0.5d0*177700d0
c      mass(62) = 1.0078d0

c --- AA for alkane methyl (CH3) carbon ---
      sigi(63) = 3.30d0
      epsi(63) = 4.0d0
      mass(63) = 12.011d0
c --- if 0.45 as C-H bond length
c      sigi(62) = 3.44d0
c      epsi(62) = 13.0d0
c      qelect(63) = -0.572d0
c      lqchg(63) = .true.

c --- AA for alkane hydrogen ---
      sigi(64) = 3.31d0
      epsi(64) = 15.3d0
      mass(64) = 1.0078d0
c      sigi(64) = 0.0d0
c      epsi(64) = 0.0d0
c      lij(64) = .false.
c      qelect(64) = 1.0d0
c      lqchg(64) = .true.

c -- AA for alkane quaternary C ---
      sigi(65) = 4.35d0
      epsi(65) = 1.0d0
      mass(65) = 12.011d0

c --- OPLS AA for alkane carbon (CH2) ---
c      sigi(65) = 3.50d0
c      epsi(65) = 33.2d0
c      mass(65) = 12.011d0
c      qelect(65) = -0.12d0
c      lqchg(65) = .true.

c --- OPLS AA for alkane hydrogen ---
      sigi(66) = 2.50d0
      epsi(66) = 15.1d0
      mass(66) = 1.0078d0
      qelect(66) = 0.06d0
      lqchg(66) = .true.

c --- OPLS-UA alkanol CH3(-O) ---
      sigi(67) = sigi(27)
      epsi(67) = epsi(27)
      mass(67) = mass(27)
      qelect(67) = 0.265d0
      lqchg(67) = .true.

C --- Teja HEPTANE at 366 K
c      sigi(68) = 6.0471d0
c      epsi(68) = 484.76d0
c      mass(68) = 100.203d0

c --- AA for alkane carbon ---
      sigi(68) = 3.65d0
      epsi(68) = 5.0d0
      mass(68) = 12.011d0
      qelect(68) = 0.265d0
      lqchg(68) = .true.
      lij(68) = .true.

C --- Teja HEPTANE at 450 K
      sigi(69) = 6.0471d0
      epsi(69) = 456.82d0
      mass(69) = 100.203d0

C --- Teja HEPTANE at 450 K
      sigi(70) = 6.0471d0
      epsi(70) = 456.82d0
      mass(70) = 100.203d0

c --- AA for CF4 Carbon (Surface Science 367(1996) P177) ---
      sigi(71) = 3.35d0
      epsi(71) = 32.73d0
      mass(71) = 12.011d0
c      qelect(71) = -0.808d0

c --- AA for CF4 Fluoro (Surface Science 367(1996) P177) ---
c      sigi(72) = 2.95d0
c      epsi(72) = 37.0d0
      sigi(72) = 2.90d0
      epsi(72) = 34.3d0
      mass(72) = 18.9984d0
c      qelect(72) = 0.202d0

c --- AA for CF4 Carbon (Nose and Klein J.Chem.Phys. 78(1983) 6928) ---
c      sigi(73) = 3.35d0
c      epsi(73) = 37.00d0
      sigi(73) = 3.35d0
      epsi(73) = 26.00d0
      mass(73) = 12.011d0
c      qelect(73) = -0.896d0

c --- AA for CF4 Fluoro (Nose and Klein J.Chem.Phys. 78(1983) 6928) ---
      sigi(74) = 2.95d0
      epsi(74) = 38.50d0
      mass(74) = 18.9984d0
c      qelect(74) = 0.224d0
 
c --- UA Methane (CH4) Freire Mol. Phys. 91, (2), 189-201 (1997)
      sigi(75) = 4.10d0
      epsi(75) = 140.0d0
      mass(75) = 16.043d0

c --- UA Methyl (CH3) Freire Mol. Phys. 91, (2), 189-201 (1997)
      sigi(76) = 4.02d0
      epsi(76) = 96.0d0
      mass(76) = 15.0347d0

c --- UA Methylene (CH2) Freire Mol. Phys. 91, (2), 189-201 (1997)
      sigi(77) = 3.72d0
      epsi(77) = 57.0d0
      mass(77) = 14.0268d0

c --- UA Methine (CH) Freire Mol. Phys. 91, (2), 189-201 (1997)
      sigi(78) = 3.36d0
      epsi(78) = 36d0
      mass(78) = 13.019d0

c --- UA Quaternary (C) Freire Mol. Phys. 91, (2), 189-201 (1997)
      sigi(79) = 2.44d0
      epsi(79) = 9.0d0
      mass(79) = 12.011d0

c --- SPC-FQ Oxygen [O] S.W. Rick et al JCP 101 (7), 1 1994 6141
      sigi(80) = 3.176
      epsi(80) = 148.0d0
      mass(80) = 15.999d0
      qelect(80) = -0.672123708
      lqchg(80) = .true.
      xiq(80) = 36899.0d0
      jayself(80) = (0.5d0)*(503.2d0)*(367.0d0)

c --- SPC-FQ Hydrogen [H] S.W. Rick et al JCP 101 (7), 1 1994 6141
      sigi(81) = 0.0d0
      epsi(81) = 0.0d0
      mass(81) = 1.0079d0
      qelect(81) = 0.336061854
      lqchg(81) = .true.
      lij(81) = .false.
      xiq(81) = 0.0d0
      jayself(81) = (0.5d0)*(503.2d0)*(392.2d0)

c --- TIP4P-FQ Oxygen [O] S.W. Rick et al JCP 101 (7), 1 1994 6141
      sigi(82) = 3.159d0
      epsi(82) = 144.1d0
c      epsi(82) = 95.0d0
c      epsi(82) = 78d0
      mass(82) = 15.999d0

c --- TIP4P-FQ Hydrogen [H] S.W. Rick et al JCP 101 (7), 1 1994 6141
      sigi(83) = 0.0d0
      epsi(83) = 0.0d0
      qelect(83) = 0.35d0
      lqchg(83) = .true.
      lij(83) = .false.
      mass(83) = 1.0079d0
      xiq(83) = 0.0d0
      jayself(83) = (0.5d0)*(503.2d0)*(353.0d0)

c --- TIP4P-FQ Charge [Q] S.W. Rick et al JCP 101 (7), 1 1994 6141
      sigi(84) = 0.0d0
      epsi(84) = 0.0d0
      qelect(84) = -0.70d0
      lqchg(84) = .true.
      lij(84) = .false.
      mass(84) = 0.0d0
      xiq(84) = 34464.0d0
      jayself(84) = (0.5d0)*(503.2d0)*(371.6d0)

c --- TIP-4P water model --- O site
      sigi(85) = 3.154d0
      epsi(85) = 78.0d0
      mass(85) = 15.999d0

c --- TIP-4P water model --- H site
      sigi(86) = 0.0d0
      epsi(86) = 0.0d0
      qelect(86) = 0.52d0
      mass(86) = 1.0079d0
      lqchg(86) = .true.
      lij(86) = .false.

c --- TIP-4P water model --- M site
      sigi(87) = 0.0d0
      epsi(87) = 0.0d0
      qelect(87) = -1.04d0
      lqchg(87) = .true.
      lij(87) = .false.

c --- OPLS alcohol CH2(-O)
      sigi(88) = sigi(28)
      epsi(88) = epsi(28)
      mass(88) = mass(28)
      qelect(88) = 0.265d0
      lqchg(88) = .true.

c --- OPLS alcohol oxygen 
      sigi(89) = 3.07d0
      epsi(89) = 85.578d0
      mass(89) = 15.999d0
      qelect(89) = -0.700d0
      lqchg(89) = .true.

c --- OPLS alcohol Hydogen
      sigi(90) = 0.0d0
      epsi(90) = 0.0d0
      mass(90) = 1.0079d0
      qelect(90) = 0.435d0
      lqchg(90) = .true.
      lij(90) = .false.

C --- SKS METHYLENE GROUP
      sigi(91) = 3.93d0 
      epsi(91) = 47.0d0 
      mass(91) = 14.0268d0

C --- Monica's alcohol methyl Not bonded to O (-CH2-) - CH3
      sigi(92) = 3.93d0
      epsi(92) = 110.0d0
      mass(92) = 15.0347d0

C --- TraPPE CH2 sp2 alkene Try 2D 04-15-99 MGM
      sigi(93) = 3.675d0
      epsi(93) = 85.0d0
      mass(93) = 14.0269d0

C --- TraPPE O-O Final parameter adjust 8-5-98
      sigi(94) = 3.07d0
      epsi(94) = 49.0d0
      mass(94) = 15.999d0

C --- Tildesley N-N 
      sigi(95) = 3.31d0
      epsi(95) = 37.3d0
      mass(95) = 14.00674d0

c --- TraPPE CH sp2 alkene Try 3B 04-15-99 MGM
      sigi(96) = 3.73d0
      epsi(96) = 47.0d0
      mass(96) = 13.0191d0

c --- TraPPE C sp2 Try A 04-15-99 MGM
      sigi(97) = 3.85d0
      epsi(97) = 20.0d0
      mass(97) = 12.011d0

c --- SPECIAL LJ CHAIN fit to give phase diagram of octane J Phys Chem 98?
      sigi(98) = 2.91d0
      epsi(98) = 236.0d0
      mass(98) = 14.0268d0

c --- Carbon in CO2 (jpotoff 12/13/99)
      sigi(99) = 2.80d0
      epsi(99) = 27.0d0
      mass(99) = 12.011d0
      qelect(99) = 0.70d0
      lqchg(99) = .true.

c --- Oxygen in CO2 (jpotoff 12/13/99)
        sigi(100) = 3.05d0
        epsi(100) = 79.0d0
        mass(100) = 15.999d0
        qelect(100) = -0.350d0 
        lqchg(100) = .true. 

c --- Carbon in ketones (jpotoff 12/13/99 + OPLS JPC v94 p1683 1990)
      sigi(101) = 3.82d0
      epsi(101) = 40.00d0
      mass(101) = 12.011d0
      qelect(101) = +0.424d0
c	qelect(101) = 0.0d0
c	lqchg(101) = .false.
      lqchg(101) = .true.

c - UA Oxygen for ketones (jpotoff 12/17/99 + OPLS JPC v94 p 1683 1990)
        sigi(102) = 3.04d0
        epsi(102) = 85.0d0
        mass(102) = 15.999d0
        qelect(102) = -0.424d0 
c	qelect(102) = 0.0d0
c	lqchg(102) = .false.
        lqchg(102) = .true. 

c --- CH2 group connected to C=O in ester
      sigi(103) = sigi(2)
      epsi(103) = epsi(2)
      qelect(103) = 0.05
      mass(103) = mass(2)
      lqchg(103) = .true.

c --- CH2 group connected to O in ester
      sigi(104) = sigi(2)
      epsi(104) = epsi(2)
      qelect(104) = 0.25
      mass(104) = mass(2)
      lqchg(104) = .true.

c --- Oxygen connected to C=O in ester (use alcohol O)
      sigi(105) = sigi(52)
      epsi(105) = epsi(52)
      qelect(105) = -0.40
      mass(105) = mass(52)
      lqchg(105) = .true.

c --- Oxygen in C=O in ester (use CO2 O)
      sigi(106) = sigi(102)
      epsi(106) = epsi(102)
      qelect(106) = -0.45
      mass(106) = mass(102)
      lqchg(106) = .true.

c --- Carbon in C=O in ester
      sigi(107) = 3.82d0
      epsi(107) = 40.0d0
      qelect(107) = 0.55
      mass(107) = 12.011d0
      lqchg(107) = .true.

c --- F in HF (OPLS)
      sigi(108) = 2.984d0
      epsi(108) = 75.75d0
      qelect(108) = 0.725d0
      mass(108) = 18.9984d0
      lqchg(108) = .true.

c --- H in HF (OPLS)
      sigi(109) = 0.0d0
      epsi(109) = 0.0d0
      qelect(109) = 0.725d0
      mass(109) = 1.0078d0
      lij(109) = .false.
      lqchg(109) = .true.

c --- M site in HF (OPLS)
      sigi(110) = 0.0d0
      epsi(110) = 0.0d0
      qelect(110) = -1.45d0
      mass(110) = 0.0d0
      lij(110) = .false.
      lqchg(110) = .true.

c --- TIP5P Oxygen 
      sigi(111) = 3.12d0
      epsi(111) = 80.512d0
      qelect(111) = 0.0d0
      mass(111) = 15.999d0
      lij(111) = .true.
      lqchg(111) = .false.

c --- TIP5P Hydrogen
      sigi(112) = 0.0d0
      epsi(112) = 0.0d0
      qelect(112) = 0.241d0
      mass(112) = 1.0078d0
      lij(112) = .false.
      lqchg(112) = .true.

c --- TIP5P lone-pair
      sigi(113) = 0.0d0
      epsi(113) = 0.0d0
      qelect(113) = -0.241d0
      mass(113) = 0.0d0
      lij(113) = .false.
      lqchg(113) = .true.

c *** TraPPE ether Oxygen
      sigi(114) = 2.8d0
      epsi(114) = 55.0d0
c      sigi(114) = 2.72d0
c      epsi(114) = 77d0
      mass(114) = 15.999d0
      qelect(114) = -0.60d0
      lqchg(114) = .true.
c *** OPLS ether Oxygen
c      sigi(114) = 3.00d0
c      epsi(114) = 85.580d0
c      mass(114) = 15.999d0
c      qelect(114) = -0.50d0
c      lqchg(114) = .true.

c --- CH in Aldehydes (jpotoff 12/13/99 + OPLS JPC v94 p1683 1990)
      sigi(115) = 3.60d0
      epsi(115) = 58.00d0
      mass(115) = 13.011d0
      qelect(115) = +0.424d0
      lqchg(115) = .true.
      
c --- Carbon in CO2-FQ (jpotoff 2/15/00)
      sigi(116) = 2.80d0
      epsi(116) = 28.5d0
      mass(116) = 12.011d0
      qelect(116) = 0.6512d0
      lqchg(116) = .true.
c      xiq(116) = (503.2d0)*123.2d0
      xiq(116) = 0.0d0
      jayself(116) = (0.5d0)*(503.2d0)*(233.5d0)

c --- Oxygen in CO2-fq (jpotoff 2/15/00)
        sigi(117) = 3.06d0
        epsi(117) = 80.5d0
        mass(117) = 15.999d0
        qelect(117) = -0.3256d0
        lqchg(117) = .true.
c        xiq(117) = (503.2d0)*201.56d0
        xiq(117) = 39430.75d0
        jayself(117) = (0.5d0)*(503.2d0)*(308.17d0)

c -- Start parameters for Dimethyl Sulfide
c --- TraPPE methyl group [CH3]-S-CH3
      sigi(118) = sigi(24)
      epsi(118) = epsi(24)
      mass(118) = mass(24)
      qelect(118) = 0.235d0
      lqchg(118) = .true.
      
c --- Sulfur CH3-[S]-CH3  (1/25/00, based on JPC v90, p6379, 1986)
      sigi(119) = 3.52d0
      epsi(119) = 158.0d0
      mass(119) = 32.07d0
      qelect(119) = -0.47d0
      lqchg(119) = .true.
      
c - end parameters for dimethyl Sulfide

c -- parameters for primary amines (2/28/00), based on JPC v94, p1683, 1990)

c -- CH3-N-[H]-H
      sigi(120) = 0.0d0
      epsi(120) = 0.0d0
      mass(120) = 1.0079d0
      qelect(120) = 0.275d0
      lqchg(120) = .true.

c -- CH3-[N]-H2
      sigi(121) = 3.31d0
      epsi(121) = 165.0d0
      mass(121) = 14.00674d0
      qelect(121) = -0.65d0
      lqchg(121) = .true.
	
c -- [CH3]-N-H2
      sigi(122) = sigi(24)
      epsi(122) = epsi(24)
      mass(122) = mass(24)
      qelect(122) = 0.10d0
      lqchg(122) = .true.

c -- end parameters for primary amines
c -- tertiary amines
c -- CH3-[N]-CH3-CH3
      sigi(123) = 3.31d0
      epsi(123) = 115.0d0
      mass(123) = 14.00674d0
      qelect(123) = -0.60d0
      lqchg(123) = .true.           

c-- CH3-[N]-CH3-H, dimethylamine
	sigi(124) = 3.31d0
	epsi(124) = 115.0d0
	mass(124) = 14.00674d0
	qelect(124) = -0.75d0
	lqchg(124) = .true.


c -- paramters for block copolymers
c -- Ether Oxygen  CH2-[O]-CH2
	sigi(125) = 2.850d0
        epsi(125) = 52.0d0
        mass(125) = 16.00d0
        qelect(125) = -0.50d0
        lqchg(125) = .true.

c -- Ether Oxygen next to carbonyl CH2-[O]-C=O
        sigi(126) = 2.850d0
        epsi(126) = 52.0d0
        mass(126) = 16.00d0
        qelect(126) = -0.25d0
        lqchg(126) = .true.

c --  [CH2]-O in ethers
        sigi(127) = sigi(2)
        epsi(127) = epsi(2)
        mass(127) = mass(2)
        qelect(127) = +0.30d0
        lqchg(127) = .true.

c -- [CH3]-O in ethers
        sigi(128) = sigi(24)
        epsi(128) = epsi(24)
        mass(128) = mass(24)
        qelect(128) = +0.25d0
        lqchg(128) = .true.

c --O=C-O-[CH2]
        sigi(129) = sigi(2)
        epsi(129) = epsi(2)
        mass(129) = mass(2)
        qelect(129) = +0.30d0
        lqchg(129) = .true.

c --- N for N2 (jpotoff 12/21/99)
	sigi(130) = 3.310d0
	epsi(130) = 36.00d0
	mass(130) = 14.00674d0
	qelect(130) = -0.50d0
	lqchg(130) = .true.

c --- COM charge cite for N2 (jpotoff 12/21/99)
	sigi(131) = 0.0d0
	epsi(131) = 0.0d0
	mass(131) = 0.0d0
	qelect(131) = 1.0d0
	lqchg(131) = .true.


c --- 105-109 Parameters for TraPPE-UA Carboxylic acids
c - TRraPPE Oxygen for Carboxylic Acids (jpotoff 12/17/99 + OPLS JPC v95 p 3315 1991)
        sigi(132) = 3.04d0
        epsi(132) = 81.0d0
        mass(132) = 15.999d0
        qelect(132) = -0.424d0 
        lqchg(132) = .true. 

c --- TraPPE iterB carbonyl carbon  -[C]OOH
      sigi(133) = 3.600
      epsi(133) = 65.00d0
      mass(133) = 12.011d0
      qelect(133) = 0.424d0
      lqchg(133) = .true.
      
c --- TraPPE CH3 in CH3-COOH
      sigi(134) = sigi(24)
      epsi(134) = epsi(24)
      mass(134) = mass(24)
      qelect(134) = 0.00d0
      lqchg(134) = .false.
            
c --- TraPPE COO[H] hydrogen (JPC v95 p. 3315, 1991)
	sigi(135) = 0.0d0
	epsi(135) = 0.0d0
	mass(135) = 1.0079d0
	qelect(135) = 0.30d0
	lqchg(135) = .true.

c - TraPPE -CO[O]H
      sigi(136) = 3.02d0
      epsi(136) = 93.0d0
      mass(136) = 16.00d0
      qelect(136) = -0.30d0
      lqchg(136) = .true.
      
c -- end parameters for Carboxylic Acids


c -- Start parameters for sulfur containing hydrocarbons
c --- TraPPE methyl group [CH3]-S-H
      sigi(137) = sigi(24)
      epsi(137) = epsi(24)
      mass(137) = mass(24)
      qelect(137) = 0.18d0
      lqchg(137) = .true.
      
c --- Sulfur CH3-[S]-H  (1/25/00, based on JPC v90, p6379, 1986)
      sigi(138) = 3.62d0
      epsi(138) = 185.0d0
      mass(138) = 32.07d0
      qelect(138) = -0.45d0
      lqchg(138) = .true.
      
c --- Hydrogen CH3-S-[H]      
      sigi(139) = 0.0d0
      epsi(139) = 0.0d0
      mass(139) = 1.0079d0
      qelect(139) = 0.27d0
      lqchg(139) = .true.
 
c --- TraPPE methylene group CH3-[CH2]-S-H
      sigi(140) = sigi(2)
      epsi(140) = epsi(2)
      mass(140) = mass(2)
      qelect(140) = 0.18d0
      lqchg(140) = .true.

c --- TraPPE methyl group [CH3]-S-[CH3]
      sigi(141) = sigi(24)
      epsi(141) = epsi(24)
      mass(141) = mass(24)
      qelect(141) = 0235d0
      lqchg(141) = .true.

c --- IAM model (COM site)
      lij(142) = .false.

c --- IAM model (A site)
      mass(143) = 1.0d0

c --- IAM model (B site)
      mass (144) = 1.0d0

c --- Sodium OPLS
c      sigi(145) = 1.738d0
c      epsi(145) = 808.45d0
      qelect(145) = 1.0d0
      mass(145) = 22.9898d0
      lqchg(145) = .true.

c --- Sodium CHARMM
c      sigi(145) = 2.429926254d0
c      epsi(145) = 23.60115354d0
      sigi(145) = 3d0
      epsi(145) = 0d0
      lhard(145) = .true.

c --- Iodide 
      sigi(146) = 4.786d0
      epsi(146) = 164.37d0
      qelect(146) = -1.0d0
      mass(146) = 126.90447d0
      lqchg(146) = .true.

c --- Chloride CHARMM
      sigi(147) = 4.04468018d0
      epsi(147) = 75.4834335d0
      qelect(147) = -1.0d0
      lqchg(147) = .true.
      mass(147) = 35.45d0

c --- hard-sphere 
      sigi(150) = 3.5 
      epsi(150) = 10d0
      mass(150) = 1.0d0 
      
c --- Computation of un-like interactions

      if ( ljoe ) then
C --- STANDARD METHYL GROUP
         extc12(1) = 3.41d7
         extc3(1)  = 20800.0d0
         extz0(1)  = 0.86d0

C --- STANDARD METHYLENE GROUP
         extc12(2) = 2.80d7
         extc3(2)  = 17100.0d0
         extz0(2)  = 0.86d0

C --- Methane
         extc12(26) = 3.41d7
         extc3(26)  = 20800.0d0
         extz0(26)  = 0.86d0

C --- Martin's methyl (CH3)
         extc12(17) = 3.41d7
         extc3(17)  = 20800.0d0
         extz0(17)  = 0.86d0
      endif

c --- Assign jayq for pairs
      do i = 1,nntype
         do j = 1,nntype
            ij = (i-1)*nntype + j
            jayq(ij) = 0.0d0
         enddo
      enddo

c - CO2-FQ Carbon-Oxygen cross term (JCO)
      i = 116
      j = 117
      djay = (503.2d0)*(133.905d0)
      ij = (i-1)*nntype + j
      ji = (j-1)*nntype + i
      jayq(ij) = djay
      jayq(ji) = djay

c - CO2-FQ Oxygen-Oxygen cross term (JOO)
      i = 117
      j = 117
      djay = (503.2d0)*(1.09d0)
      ij = (i-1)*nntype + j
      jayq(ij) = djay

c --- SPC-FQ water Oxygen-Hydrogen cross term
      i = 80
      j = 81
      djay = (503.2d0)*(276.0d0)
      ij = (i-1)*nntype + j
      ji = (j-1)*nntype + i
      jayq(ij) = djay
      jayq(ji) = djay
      
c --- SPC-FQ water Hydrogen-Hydrogen cross term
      i = 81
      j = 81
      djay = (503.2d0)*(196.0d0)
      ij = (i-1)*nntype + j
      jayq(ij) = djay

c --- TIP4P water Charge-Hydrogen cross term
      i = 83
      j = 84
      djay = (503.2d0)*(286.4d0)
      ij = (i-1)*nntype + j
      ji = (j-1)*nntype + i
      jayq(ji) = djay
      jayq(ij) = djay

c --- TIP4P water Hydrogen-Hydrogen cross term
      i = 83
      j = 83
      djay = (503.2d0)*(203.6d0)
      ij = (i-1)*nntype + j
      jayq(ij) = djay

c --- Methane C-H cross term
      i = 26
      j = 62
      ij = (i-1)*nntype + j
      ji = (j-i)*nntype + i
      jayq(ji) = 114855.0d0
      jayq(ij) = 114855.0d0

c --- Methane H-H cross term
      i = 62
      j = 62
      ij = (i-1)*nntype + j
      jayq(ij) = 112537.0d0


c *** convert input data to program units ***
      if ( lsami ) then
         call susami
         rcheck = 2.5d0 * 3.527d0
         if ( rcut .ne. rcheck ) then
            write(istdout,*) 'WARNING ### rcut set to 2.5sigma for SAMI'
            rcut = rcheck
         endif
      else
c *** calculate square sigmas and epsilons for lj-energy subroutines ***
         do i = 1, nntype
            do j = 1, nntype
               ij = (i-1)*nntype + j
               if ( lspecial(ij) ) then
                  write(istdout,*) 'ij,lspecial(ij)',ij,lspecial(ij)
                  adum = aspecial(ij)
                  bdum = bspecial(ij)
               else
                  adum = 1.0d0
                  bdum = 1.0d0
               endif
c --- Lorentz-Berthelot rules --- sig_ij = 0.5 [ sig_i + sig_j ]
               if ( lmixlb ) then
                  sig2ij(ij) =(adum* 0.5d0 * ( sigi(i) + sigi(j) ) )**2
                  if ( sigi(i) .eq. 0.0d0 .or. sigi(j) .eq. 0.0d0 )
     &                 sig2ij(ij) = 0.0d0
                  if (epsi(i) .lt. 0.0d0 .or. epsi(j) .lt. 0.0d0) then
                     epsij(ij) = -1.0d0
                  else 
                     epsij(ij) = bdum*dsqrt( epsi(i) * epsi(j) )
                  endif
               endif
c --- Jorgensen mixing rules --- sig_ij = [ sig_i * sig_j ]^(1/2)
               if(lmixjo) then
                  sig2ij(ij) = adum*adum*sigi(i) * sigi(j)
                  epsij(ij) = bdum*dsqrt( epsi(i) * epsi(j) )
               endif

	       if (lshift) then
                   sr2 = sig2ij(ij) / (rcut*rcut)
                   sr6 = sr2 * sr2 * sr2
                   ecut(ij)= sr6*(sr6-1.0d0)*epsij(ij)
	       endif

            enddo
         enddo
      endif
c ---  Conversion factor for intermolecular coulomb interactions
      qqfact = 1.67d5

      return
      end





