      subroutine sumup( ovrlap, v, vinter,vtail,vintra,vvib,
     +                  vbend,vtg,vext,velect,vflucq,ibox)
 
c    *******************************************************************
c    ** calculates the total potential energy for a configuration.    **
c    **                                                               **
c    ** logical ovrlap            true for substantial atom overlap   **
c    *******************************************************************
 
      implicit none

c *** common blocks ***
      include 'control.inc'
      include 'coord.inc'
      include 'system.inc'
      include 'poten.inc'
      include 'connect.inc'
      include 'inputdata.inc'
      include 'qqlist.inc'
      include 'neigh.inc'
      include 'parallel.inc'

      logical ovrlap
      logical lqimol,lqjmol,lcoulo,lij2,liji,lqchgi
      integer i, imolty, ii, j, jmolty, jj, ntii, ntjj, ntij, iunit
     +     , ip1, ip2, ip3,ibox,iii,jjj,ip
     +     ,iivib, jjvib, jjben, jjtor, it, ntj,itype,k
      double precision v, vinter, vintra, vtail, vvib, vbend, vtg, vext
     &     ,velect,vflucq,qqii
      double precision rcutsq,rxui,ryui,rzui,rxuij,ryuij,rzuij
     &       ,rijsq,sr2, sr6, rho, thetac, theta 
     +     ,xaa1, yaa1, zaa1, xa1a2, ya1a2, za1a2, daa1, da1a2, dot
     +     ,vtorso

      double precision xvec(numax,numax),yvec(numax,numax)
     +                ,zvec(numax,numax),distij(numax,numax),epsilon2
     +                ,sigma2

      dimension lcoulo(numax,numax)
      double precision vij,viijj,vqiijj
c --------------------------------------------------------------------

c      write(6,*) 'start SUMUP'
      ovrlap = .false.

      v = 0.0d0
      vinter = 0.0d0
      vintra = 0.0d0
      vtail = 0.0d0
      vtg = 0.0d0
      vbend = 0.0d0
      vvib = 0.0d0
      vext = 0.0d0
      velect = 0.0d0
      vflucq = 0.0d0
      vij = 0d0
      viijj = 0d0
      vqiijj = 0d0

      do i = 1, nchbox(ibox)
         neigh_cnt(i) = 0
         if ( lene_w ) then
            ene1(i) = 0d0
            ene2(i) = 0d0
         endif
      enddo
      if ( lene_cut ) then
         do i = 1, nchbox(ibox)
            neigh_cnt2(i) = 0
         enddo
      endif

c ###############################################################

C *******************************
C *** INTERCHAIN INTERACTIONS ***
C *******************************

c --- loop over all chains i 
c --- not if lgrand and ibox =2
      do 100 i = 1, nchbox(ibox) - 1
         
         imolty = moltyp(i)
         lqimol = lelect(imolty)
                      
c --- loop over all chains j with j>i 
         do 99 j = i + 1, nchbox(ibox)
            
            jmolty = moltyp(j)
            lqjmol = lelect(jmolty)
            
 98         vij = 0.0d0
            do ii = 1,nunit(imolty)
               ntii = ntype(imolty,ii)
               lqchgi = lqchg(ntii)
               liji = lij(ntii)
               rxui = rxu(i,ii)
               ryui = ryu(i,ii)
               rzui = rzu(i,ii)
               
c --- loop over all beads jj of chain j 
               do 97 jj = 1, nunit(jmolty) 
c --- check exclusion table
                  if ( lexclu(imolty,ii,jmolty,jj) ) goto 97
                  
                  ntjj = ntype(jmolty,jj)
                  ntij = (ntii-1)*nntype + ntjj
                  
                  rxuij = rxui - rxu(j,jj)
                  ryuij = ryui - ryu(j,jj)
                  rzuij = rzui - rzu(j,jj)
c *** minimum image the pair separations ***
                  rijsq = (rxuij*rxuij)+(ryuij*ryuij)
     &                 + (rzuij*rzuij)
                         
c                  write(6,*) rijsq,rvdwsq,vinter
                  if ( rijsq .lt. rminsq ) then
                     write(6,*) 'overlap inter'
                     write(6,*) 'rijsq rminsq', rijsq, rminsq
                     write(6,*) 'i ii', i, ii
                     write(6,*) 'i-pos', rxui,ryui,rzui
                     write(6,*) 'j jj', j, jj
                     write(6,*) 'j-pos', 
     &                    rxu(j,jj),ryu(j,jj),rzu(j,jj)
                     ovrlap = .true.
                     return
                  elseif ( rijsq .lt. rvdwsq .or. lijall) then
                     if ( liji .and. lij(ntjj) ) then
                        if ( lhard(ntii) .or. lhard(ntjj) ) then
                           if ( rijsq .lt. sig2ij(ntij) ) then
                              ovrlap = .true.
                              return
                           else
                              viijj = 0d0
                           endif
                        else
                           if (lshift) then
                              sr2 = sig2ij(ntij) / rijsq
                              sr6 = sr2 * sr2 * sr2
                              vinter = vinter + sr6*(sr6-1.0d0)
     +                             *epsij(ntij)-ecut(ntij) 
                           else
                              sr2 = sig2ij(ntij) / rijsq 
                              sr6 = sr2 * sr2 * sr2
                              viijj = sr6*(sr6-1.0d0)*epsij(ntij)
                              vinter = vinter + viijj
                              if ( lene_w ) then
                                 ene1(i) = ene1(i) + viijj
                                 ene1(j) = ene1(j) + viijj
                              endif
                           endif
                        endif
                     endif
                  endif

                  if (lchgall) then
                     if (lqchgi .and. lqchg(ntjj)) then
                        vqiijj = qqu(i,ii)*qqu(j,jj)/dsqrt(rijsq)
                        velect = velect + vqiijj
                        if ( lene_w ) then
                           ene2(i) = ene2(i) + vqiijj
                           ene2(j) = ene2(j) + vqiijj
                        endif
                     endif
                  elseif ( lqimol .and. lqjmol ) then

c --- All-Atom charges (charge-group look-up table)

                     iii = leaderq(imolty,ii)
                     jjj = leaderq(jmolty,jj)
                     
                     if ( iii .eq. ii .and. jjj .eq. jj )then
c     --- set up the table
                        if ( rijsq .lt. rchgsq ) then
                           lcoulo(iii,jjj) = .true.
                        else
                           lcoulo(iii,jjj) = .false.
                        endif
                     endif
                     
                     if (lcoulo(iii,jjj)) then
                        if ( lqchgi .and. lqchg(ntjj) ) then
                           vqiijj = qqu(i,ii)*qqu(j,jj)/dsqrt(rijsq)
                           velect = velect + vqiijj
                           if ( lene_w ) then
                              ene2(i) = ene2(i) + vqiijj
                              ene2(j) = ene2(j) + vqiijj
                           endif
                        endif
                     endif
                            
                  endif
                         
                  if ( ii .eq. 1 .and. jj .eq. 1 ) then
                     if (rijsq .lt. rbsmaxsq(imolty,jmolty)
     &                    .and. rijsq .gt. rbsminsq(imolty,jmolty)) then
                        
                        neigh_cnt(i)=neigh_cnt(i)+1
                        neighbor(neigh_cnt(i),i)=j
                        neigh_cnt(j)=neigh_cnt(j)+1
                        neighbor(neigh_cnt(j),j)=i
                           
                     endif
                  endif
                  if ( lene_cut ) then
                     vij = vij+viijj*4d0+vqiijj*qqfact
                     viijj = 0.0d0
                     vqiijj = 0d0
                  endif

                         
 97            continue

            enddo
            if ( lene_cut ) then
               if ( vij .lt. ene_cut(imolty,jmolty) ) then
                  neigh_cnt2(i)=neigh_cnt2(i)+1
                  neighbor2(neigh_cnt2(i),i)=j
                  neigh_cnt2(j)=neigh_cnt2(j)+1
                  neighbor2(neigh_cnt2(j),j)=i
               endif
               vij = 0.0d0
            endif
 99      continue
         
 100  continue

      vinter = 4.0d0 * vinter


c ################################################################

C *******************************
C *** INTRACHAIN INTERACTIONS ***
C *******************************
c         write(6,*) 'starting intrachain'
c --- loop over all chains i 

      do i = 1, nchbox(ibox)

         imolty = moltyp(i)
         do ii = 1, nunit(imolty)-1

            ntii = ntype(imolty,ii)

            rxui = rxu(i,ii)
            ryui = ryu(i,ii)
            rzui = rzu(i,ii)

            do jj = ii+1, nunit(imolty)
                  
               if ( linclu(imolty,ii,jj) ) then

                  ntjj = ntype(imolty,jj)
                  ntij = (ntii-1)*nntype + ntjj
                  rxuij = rxu(i,ii) - rxu(i,jj)
                  ryuij = ryu(i,ii) - ryu(i,jj)
                  rzuij = rzu(i,ii) - rzu(i,jj)

                  rijsq = rxuij*rxuij + ryuij*ryuij + rzuij*rzuij
                     
                  if ( rijsq .lt. rvdwsq .or. lijall) then
                     if ( lhard(ntii) .or. lhard(ntjj) ) then
                        if ( rijsq .lt. sig2ij(ntij) ) then
                           ovrlap = .true.
                           return
                        endif
                     else
                        if ( lshift ) then
                           sr2 = sig2ij(ntij) / rijsq
                           sr6 = sr2 * sr2 * sr2
                           vintra = vintra + 
     +                          sr6*(sr6-1.0d0)*epsij(ntij)-ecut(ntij) 
                        else
                           sr2 = sig2ij(ntij) / rijsq
                           sr6 = sr2 * sr2 * sr2
                           vintra = vintra + 
     +                          sr6*(sr6-1.0d0)*epsij(ntij)
                        endif
                     endif
                     if ( lqchg(ntii) .and. lqchg(ntjj) ) then
                        velect = velect+qqu(i,ii)*qqu(i,jj)/dsqrt(rijsq)
                     endif
                  endif
               endif
            enddo
         enddo
      enddo
      
      vintra = 4.0d0 * vintra
 
c ################################################################

C **************************************************
C *** CALCULATION OF VIB. + BEND. + TORS. ENERGY ***
C **************************************************

C NOTE here virtual coordinates can be used!!!
c
      do i = 1, nchbox(1)
          
         imolty = moltyp(i)

c - branched and linear molecules with connectivity table -
c - go through entire chain -
c - calculate all bonds vectors and lengths
c - calculate all stretching, bending, and torsional potentials
c - that have an end-bead with an index smaller than the current bead
         do ii = 1, nunit(imolty)
            rxui=rxu(i,ii)
            ryui=ryu(i,ii)
            rzui=rzu(i,ii)
            do iivib = 1, invib(imolty,ii)
               jj = ijvib(imolty,ii,iivib)
               xvec(ii,jj) = rxu(i,jj) - rxui
               yvec(ii,jj) = ryu(i,jj) - ryui
               zvec(ii,jj) = rzu(i,jj) - rzui
               distij(ii,jj) = dsqrt( xvec(ii,jj)**2
     +              + yvec(ii,jj)**2 + zvec(ii,jj)**2 )
               
               if ( nunit(imolty) .ne. nugrow(imolty) )then
c     --- account for explct atoms in opposite direction
                  xvec(jj,ii)   = -xvec(ii,jj)
                  yvec(jj,ii)   = -yvec(ii,jj)
                  zvec(jj,ii)   = -zvec(ii,jj)
                  distij(jj,ii) = distij(ii,jj)
               endif
            enddo
         enddo
            
c - stretching -
         if ( brvibk(1) .gt. 0.01d0 ) then
            do j = 2, nunit(imolty)
               do jjvib = 1, invib(imolty,j)
                  ip1 = ijvib(imolty,j,jjvib)
                  it  = itvib(imolty,j,jjvib)
                  if ( ip1 .lt. j ) vvib = vvib + 
     +                 brvibk(it) * ( distij(ip1,j) - brvib(it) )**2
               enddo
            enddo
         endif

c - bending -
c ### molecule with bond bending 
         do j = 3, nunit(imolty)
            do jjben = 1, inben(imolty,j)
               ip2 = ijben3(imolty,j,jjben)
               if ( ip2 .lt. j ) then
                  ip1 = ijben2(imolty,j,jjben)
                  it  = itben(imolty,j,jjben)
                  thetac = ( xvec(ip1,j)*xvec(ip1,ip2) +
     +                 yvec(ip1,j)*yvec(ip1,ip2) +
     +                 zvec(ip1,j)*zvec(ip1,ip2) ) /
     +                 ( distij(ip1,j)*distij(ip1,ip2) )
                  if ( thetac .ge. 1.0d0 ) thetac = 1.0d0
                  if ( thetac .le. -1.0d0 ) thetac = -1.0d0
                  
                  theta = dacos(thetac)
                  vbend = vbend + 
     +                 brbenk(it) * (theta-brben(it))**2
                   
c                      write(6,*) 'ip2,ip1,j',ip2,ip1,j
c                      write(6,*) 'bend energy, theta '
c     &                     ,brbenk(it) * (theta-brben(it))**2,theta
               endif
            enddo
         enddo

c - torsions -
c ### molecule with dihedral potenials ###
         do j = 4, nunit(imolty)
            do jjtor = 1, intor(imolty,j)
               ip3 = ijtor4(imolty,j,jjtor)
               if ( ip3 .lt. j ) then
                  ip1 = ijtor2(imolty,j,jjtor)
                  ip2 = ijtor3(imolty,j,jjtor)
                  it  = ittor(imolty,j,jjtor)
c*** calculate cross products d_a x d_a-1 and d_a-1 x d_a-2 ***
                  xaa1 = yvec(ip1,j) * zvec(ip2,ip1) +
     +                 zvec(ip1,j) * yvec(ip1,ip2)
                  yaa1 = zvec(ip1,j) * xvec(ip2,ip1) +
     +                 xvec(ip1,j) * zvec(ip1,ip2)
                  zaa1 = xvec(ip1,j) * yvec(ip2,ip1) +
     +                 yvec(ip1,j) * xvec(ip1,ip2)
                  xa1a2 = yvec(ip1,ip2) * zvec(ip2,ip3) +
     +                 zvec(ip1,ip2) * yvec(ip3,ip2)
                  ya1a2 = zvec(ip1,ip2) * xvec(ip2,ip3) +
     +                 xvec(ip1,ip2) * zvec(ip3,ip2)
                  za1a2 = xvec(ip1,ip2) * yvec(ip2,ip3) +
     +                 yvec(ip1,ip2) * xvec(ip3,ip2)
c *** calculate lengths of cross products ***
                  daa1 = dsqrt(xaa1**2+yaa1**2+zaa1**2)
                  da1a2 = dsqrt(xa1a2**2+ya1a2**2+za1a2**2)
c *** calculate dot product of cross products ***
                  dot = xaa1*xa1a2 + yaa1*ya1a2 + zaa1*za1a2
                  thetac = - dot / ( daa1 * da1a2 )

                  vtg = vtg + vtorso( thetac, it )
c                      write(6,*) 'vtg:',vtg,it
               endif
            enddo
         enddo
      enddo
 
      velect = qqfact*velect 
      v = vinter + vintra + vvib + vbend + vtg + vext + velect 

      write(istdout,*)
      write(istdout,*) 'sumup control'
      write(istdout,*) 'number of chains', nchbox(ibox)
      do i = 1, nmolty
         write(istdout,*) 'number of chains of type',i,ncmt(ibox,i)
      enddo
      write(istdout,*) 'inter lj energy ', vinter
      write(istdout,*) 'intra lj energy ', vintra
      if (ltailc) write(istdout,*)
     +     'Tail correction ', vtail
      
      write(istdout,*) 'bond vibration  ', vvib
      write(istdout,*) 'bond bending    ', vbend
      write(istdout,*) 'torsional       ', vtg
      write(istdout,*) 'external surf.  ', vext
      write(istdout,*) 'coulombic energy', velect
c     write(istdout,*) 'exact energy    ',
c     +        1.74756*1.67*831.441/3.292796
      write(istdout,*) 'fluc Q energy   ', vflucq
      write(istdout,*) 'total energy    ', v

c      write(istdout,*) 'end SUMUP'

      return
      end
