      subroutine swap(bsswap,bnswap,qelect)
      
c    ********************************************************************
c    ** removes a molecule from one box and inserts it into the other  **
c    ** using CBMC insertion techniques.  Works for linear or branched **
c    ** molecules and for DC-CBMC and Explicit atom                    **
c    ** Rewritten from old swap and swapbr subroutines by M.G. Martin  **
c    ** 9-18-97                                                        ** 
c    ********************************************************************
 
      implicit none
      
      include 'control.inc'
      include 'coord.inc'
      include 'conver.inc'
      include 'coord2.inc'
      include 'system.inc'
      include 'ensemble.inc'
      include 'cbmc.inc'
      include 'rosen.inc' 
      include 'connect.inc'
      include 'inputdata.inc'
      include 'poten.inc'
      include 'neigh.inc'
      
      logical ovrlap,lterm,lnew,lempty,ldone,ltors,lovrh,lfavor,
     &     laccept,lrem_out,lins_in,lneighij,linsk_in,
     &     lremk_in,lrem_clu,lins_clu

      integer boxins,boxrem,imol,ichoi,ip,iwalk,idum
      integer istt,iett,ncount,itype,ipair,ipairb,ii,jj,kk

      integer iutry,icbu,ifrom,irem,iins,glist
     &     ,iii,j,ibox,iunit,ic,pointp,imolty,imt,jmt,igrow
     &     ,pointp2,jins,jmolty,neighj_num,neighk_num
     &     ,joffset,koffset,kmolty,kins,target
     &     ,k,neigh_old,nij,jchain

      dimension glist(numax)

      double precision v,vintra,vinter,vext,velect,vtorold,vtornew
     &     ,vewald,vflucq,delen,deleo,rpair
      double precision vnewflucq,voldflucq,qion
      dimension qion(numax)
      double precision rxuold,ryuold,rzuold
      dimension rxuold(numax),ryuold(numax),rzuold(numax)
      double precision bsswap,bnswap,bnswap_in,bnswap_out
      double precision random,rmol,qelect,rbf,bsum
      double precision waddnew,waddold
      
      double precision v1insext,v1remext,v1ins,w1ins,v1rem,w1rem
     &     ,v1insint,v1remint,v1insewd,v1remewd
     &     ,wnlog,wolog,wdlog,wratio,vinsta,vremta
     &     ,volins,volrem,rho,arg,coru,v1inselc,v1remelc,vbias
      double precision rvol,x,y,z,rijsq,wbias_ins,wbias_rem,r
     &     ,xi1,xi2,xisq
      dimension bsswap(ntmax,npabmax,nbxmax*2),
     &     bnswap(ntmax,npabmax,nbxmax*2),bnswap_in(ntmax,2),
     &     bnswap_out(ntmax,2)
      dimension qelect(nntype)
      double precision vrecipn,vrecipo,vdum,whins,whrem
      double precision rxuh,ryuh,rzuh,delenh,vtrhext,vtrhintra
     &     ,vtrhinter,vtrhelect,vtrhewald,vtrhtg,bfach
      dimension bfach(nchmax),delenh(nchmax),vtrhinter(nchmax)
     &     ,vtrhext(nchmax),vtrhintra(nchmax),vtrhelect(nchmax)
     &     ,vtrhewald(nchmax),vtrhtg(nchmax)
      dimension lovrh(nchmax)
      dimension rxuh(numax,nchmax),ryuh(numax,nchmax)
     +     ,rzuh(numax,nchmax)
      double precision rxui,ryui,rzui
      integer index_i(nmax,2),clumax,ncmt_max,imol_max,ioffset
     &     ,imol_maxo
      double precision rbsmax,rbsmin,vol_max,vol_min,vol_eff,roo,roh
     &     ,ene_wi,ene_w,ene_wj(nmax)
C --------------------------------------------------------------------

c      write(6,*) 'START SWAP'

      lempty = .false.
      rmol = random()
      ldone = .false.
      do imol = 1, nmolty
         if ( rmol .lt. pmswmt(imol) ) then
            if ( .not. ldone ) then
               imolty = imol
               ldone = .true.
            endif
         endif
      enddo

      rmol = random()
      ldone = .false.
      do imol = 1, nmolty
         if ( rmol .lt. pmbsmt(imolty,imol) ) then
            if ( .not. ldone ) then
               jmolty = imol
               ldone = .true.
            endif
         endif
      enddo
      if ( ncmt(1,jmolty) .eq. 0 ) then
c         write(6,*) jmolty,pmbsmt(imolty,jmolty),ncmt(1,1)
c         write(6,*) 'return 1',jmolty,ncmt(1,jmolty)
         return
      endif

      if ( imolty .eq. jmolty ) then
         nij = 1
      else
         nij = 0
      endif
      rbsmax = rbmax(imolty)+rbmax(jmolty)
      rbsmin = rbmin(imolty)+rbmin(jmolty)

      if ( l2d ) then
         vol_max = rbsmax*rbsmax
         vol_min = rbsmin*rbsmin
         vol_eff = onepi*(vol_max-vol_min)
      else
         vol_max = rbsmax*rbsmax*rbsmax
         vol_min = rbsmin*rbsmin*rbsmin
         vol_eff = (4d0/3d0)*onepi*(vol_max-vol_min)
      endif

      if (random().lt.0.5d0) then
         boxins=1
         boxrem=2
      else
         boxins=2
         boxrem=1
      endif
      
c *** select a chain in BOXREM at random ***

      if (.not. lempty) bnswap(imolty,1,boxins) 
     &     = bnswap(imolty,1,boxins) + 1.0d0
      bsswap(imolty,1,boxins) = bsswap(imolty,1,boxins)+1.0d0
      
      iunit = nunit(imolty)
      igrow = nugrow(imolty)

      if ( lmisc ) then
         iins = n1 + 1
      else
         iins = nsum + 1
      endif

      moltyp(iins) = imolty

c *** select a position of the first/starting unit at RANDOM ***
c *** and calculate the boltzmann weight                     ***
c *** for the chain to be INSERTED                           ***

      wbias_ins = 1.0d0
      wbias_rem = 1.0d0

      ichoi = nchoi1(imolty)

         
c *** box 1 is the real box and should have at least 1 molecule

c      if ( ncmt(1,imolty) .eq. n0 .and. boxrem .eq. 1) then
      if ( boxrem .eq. 1 ) then
               
         if (nchbox(1) .eq. n0) then
c            write(6,*) 'return 2'
            return
         else
            if ( ncmt(1,imolty) .eq. 0 ) then
c               write(6,*) 'return 3',imolty
               return

            endif
         endif

c ??? what shall we do now?
c         lempty = .true.
c         return 
            
      elseif ( boxins .eq. 1 ) then
         if ( lmisc ) then
            if ( nchbox(1)+1 .gt. n1 ) 
     &           return 
         else
            if ( imolty .eq. 1 ) then
               if ( ncmt(1,imolty)+1 .gt. n1 ) 
     &              return
            elseif ( imolty .eq. 2 ) then
               if ( ncmt(1,imolty)+1 .gt. n2 ) 
     &              return
            else
               if ( ncmt(1,imolty)+1 .gt. n3 ) 
     &              return
            endif
         endif
      endif
      
      if ( lcluster1 ) then
         jins = 1
      else
         pointp2=idint( dble(ncmt(1,jmolty))*random())+1
         jins = parbox(pointp2,1,jmolty)
         
         if ( moltyp(jins) .ne. jmolty ) 
     &        write(6,*) 'screwup swap, jins:'
     &        ,jins,moltyp(jins),jmolty
         if ( nboxi(jins) .ne. 1 ) then
            write(6,*) ncmt(1,imolty),jins,nboxi(jins)
            stop 'problem in swap with jins'
         endif
      endif
            

      neighj_num = neigh_cnt(jins)

      if ( boxins .eq. 1 ) then
         if ( lcluster1 ) then
            wbias_rem = 1.0d0/vol_eff
         else
            wbias_rem = 1.0d0/vol_eff/ncmt(1,jmolty)
         endif
         lins_in = .true.

c *** select a particle in the out region and move this particle into
c *** the in region defined by the particle jins's bonding region
c *** out -> j case
         
         lrem_out = .true.
         irem = nchbox(1)+1
         moltyp(irem) = imolty

         do icbu = 1, iunit
            qqu(iins,icbu) = qelect(ntype(imolty,icbu))
         enddo

         do icbu = 1,ichoi
c *** choose a random association distance
            rvol = random()
            if ( l2d ) then
               r = dsqrt(vol_min+(vol_max-vol_min)*rvol)
               xi1 = onepi*2d0*random()
               x = r * dcos(xi1)
               y = r * dsin(xi1)
               rxp(1,icbu) = rxu(jins,1) + x
               ryp(1,icbu) = ryu(jins,1) + y
               rzp(1,icbu) = rzu(jins,1)
            else
            r = (vol_max*rvol + 
     &           (1.0d0-rvol)*vol_min)**(1.0d0/3.0d0)
            
c --- calculate random vector on the unit sphere ---
 109        xi1 = ( 2.0d0 * random() ) - 1.0d0
            xi2 = ( 2.0d0 * random() ) - 1.0d0
            xisq = xi1**2 + xi2**2
            if ( xisq .lt. 1.0d0 ) then
               x = r * 2.0d0 * xi1 * dsqrt( 1.0d0 - xisq )
               y = r * 2.0d0 * xi2 * dsqrt( 1.0d0 - xisq )
               z = r * ( 1.0d0 - 2.0d0 * xisq )
            else
               goto 109
            endif
            rxp(1,icbu) = rxu(jins,1) + x
            ryp(1,icbu) = ryu(jins,1) + y
            rzp(1,icbu) = rzu(jins,1) + z
            endif
         enddo

c     *** select starting unit ***
c     --- always using bead 1 as the starting unit
         iutry = 1
         lnew = .true.
         glist(1) = 1
c     --  insert the first atom
         call boltz(lnew,.true.,lins_in,ovrlap,iins,iins,imolty,boxins,
     &        ichoi,idum,1,glist,0.0d0)
         
c         write(6,*) 'after boltz'

         if ( ovrlap ) return 
      
c     *** perform the walk according to the availibility of the choices ***
c     *** and calculate the correct weight for the trial walk           ***
      
         w1ins = 0.0d0
         do ip = 1, ichoi
            w1ins = w1ins + bfac(ip)
         enddo
         
c     --- check for termination of walk ---
         if ( w1ins .lt. softlog ) then
c            write(6,*) 'caught in swap'
            return
         endif
      
c     --- select one position at random ---
         if ( ichoi .gt. 1 ) then
            rbf = w1ins * random()
            bsum = 0.0d0 
            do ip = 1, ichoi
               if ( .not. lovr(ip) ) then
                  bsum = bsum + bfac(ip)
                  if ( rbf .lt. bsum ) then
c     --- select ip position ---
                     iwalk = ip
                     goto 180
                  endif
               endif
            enddo
            write(6,*) 'w1ins:',w1ins,'rbf:',rbf
            stop 'big time screwup -- w1ins'
         else
            iwalk = 1
         endif
      
 180     v1ins =  vtry(iwalk)  
         v1insext = vtrext(iwalk)
         v1insint = vtrinter(iwalk)
         v1inselc = vtrelect(iwalk)
         v1insewd = vtrewald(iwalk)

         rxnew(1) = rxp(1,iwalk)
         rynew(1) = ryp(1,iwalk)
         rznew(1) = rzp(1,iwalk)

         call schedule(igrow,imolty,ifrom,iutry,0,2)
      
c     ------------------------------------------------------------------
      
         lterm = .false.

         call rosenbluth( .true.,lterm,iins,iins,imolty,ifrom
     &        ,boxins,igrow )
         
c         write(6,*) 'after rosen'

c     --- termination of cbmc attempt due to walk termination ---
         if ( lterm ) return 

         waddnew = 1.0d0

         if ( ldual .or. (igrow .ne. iunit) ) then
            iii = 2
            do j=1,igrow
               rxuion(j,iii) = rxnew(j)
               ryuion(j,iii) = rynew(j)
               rzuion(j,iii) = rznew(j)
               qquion(j,iii) = qqu(iins,j)
            enddo
            moltion(iii) = imolty
            if ( igrow .ne. iunit ) then
               idum = nchbox(1)+2
               do j=1,igrow
                  rxu(idum,j) = rxnew(j)
                  ryu(idum,j) = rynew(j)
                  rzu(idum,j) = rznew(j)
               enddo
               moltyp(idum) = imolty
               call explct(idum,vtornew,.false.,.false.)
               do j=igrow+1,iunit
                  rxuion(j,iii) = rxu(idum,j)
                  ryuion(j,iii) = ryu(idum,j)
                  rzuion(j,iii) = rzu(idum,j)
                  qquion(j,iii) = qqu(iins,j)
               enddo
            else
               vtornew = 0d0
            endif   
            ibox=boxins
            nboxi(iins) = ibox
            istt = 1
            iett = iunit
            
            call energy (iins,imolty, v, vintra,vinter,vext,velect
     &           ,vewald, iii, ibox
     &           ,istt, iett, .true.,ovrlap,.false.,vdum,.false.)
            
c            write(6,*) 'after energy'

            if (ovrlap) then
c               write(6,*) 'iins',iins,'irem',irem,neigh_icnt2
c               stop 'strange screwup in DC-CBMC swap'
               return 
            endif
c            write(6,*) neigh_icnt2
            if ( lene_cut .and. neigh_icnt2 .eq. 0 ) then
               return
            endif

            if ( lene_w ) then
               ene_wi=dexp(beta*(ene3(iins,2)*4d0+ene4(iins,2)*qqfact))
               ene_w = ene_wi
               do j = 1, neighj_num
                  ii = neighbor(j,jins)
                  if ( moltyp(ii) .eq. imolty ) 
     &                 ene_w = ene_w+dexp(beta*((ene1(ii)+ene3(ii,2))*
     &                 4d0+(ene2(ii)+ene4(ii,2))*qqfact))
               enddo
            endif

            delen = v - ( vnewinter + vnewintra+vnewext +vnewelect) 
     &           - (v1ins - v1insewd)
            waddnew = waddnew*dexp(-beta*delen)
            vnewt     = vnewt + delen
            vnewinter = vinter - v1insint
            vnewintra = vintra
            vnewext   = vext - v1insext
            vnewelect = velect
         endif
         
c *** for the reverse part
         
         if ( lcluster1 ) then
            wbias_ins = 1.0d0/(ncmt(1,imolty))
         else
            wbias_ins = 1.0d0/(ncmt(1,jmolty)+nij)
            if ( lene_w ) then
               wbias_ins = wbias_ins*ene_wi/ene_w
            else
               wbias_ins = wbias_ins/(neighj_num+1d0)
            endif
         endif
         v1rem = 0d0
         v1remint = 0d0
         w1rem = dble(ichoi)
         waddold = 1.0d0
         do j=1,igrow
            rxu(irem,j) = rxu_gas(imolty,j)
            ryu(irem,j) = ryu_gas(imolty,j)
            rzu(irem,j) = rzu_gas(imolty,j)
         enddo
c     --- call rosenbluth for old conformation
         call rosenbluth(.false.,lterm,irem,irem,imolty,ifrom
     &        ,boxrem,igrow )
c         write(6,*) 'after old rosen'

         voldt = 0d0
         voldinter = 0d0
         voldelect = 0d0
         voldewald = 0d0
         voldintra = 0d0
         voldtg = 0d0
         voldbb = 0d0
         voldbvib = 0d0
         vtorold = 0d0
      else
            
         lins_in = .false.

c *** select a particle in the in region defined by the particle 
c *** jins's bonding region through neighbor list 
c *** and move to the out region or the region bounded by kins in AVBMC3

         if ( lcluster1 ) then
 22         pointp=idint(dble(ncmt(boxrem,imolty))*random())+1
            irem = parbox(pointp,boxrem,imolty)
            if ( moltyp(irem) .ne. imolty ) 
     &           write(6,*) 'screwup swap1, irem:',irem,
     &           moltyp(irem),imolty,boxrem
            ibox = nboxi(irem)
            if ( ibox .ne. boxrem ) then
               write(6,*) irem,ibox,boxrem
               stop 'problem in swap'
            endif
            if ( irem .eq. 1 ) goto 22

         else
            if ( neighj_num .eq. 0 ) then

c ??? what shall we do now?
               lempty = .true.
               return
            else
               if ( lene_w ) then
                  ene_w = 0d0
                  do j = 1,neighj_num
                     ii = neighbor(j,jins)
                     if ( moltyp(ii) .eq. imolty ) then
                        ene_wj(j) = dexp(beta*(ene1(ii)*4d0+
     &                       ene2(ii)*qqfact))
                     else
                        ene_wj(j) = 0d0
                     endif
                     ene_w = ene_w+ene_wj(j)
                  enddo
                  if ( ene_w .lt. softlog ) then
                     return
                  endif
                  rbf = ene_w*random()
                  bsum = 0d0
                  do j = 1,neighj_num
                     bsum = bsum+ene_wj(j)
                     if ( rbf .lt. bsum ) then
                        irem = neighbor(j,jins)
                        ene_wi = ene_wj(j)
                        goto 102
                     endif
                  enddo
               else
                  pointp2=idint(dble(neighj_num)*random())+1
                  irem = neighbor(pointp2,jins)
               endif

 102           if ( moltyp(irem) .ne. imolty ) then
                  return
               endif
               ibox = nboxi(irem)
               if ( ibox .ne. boxrem ) stop 'problem in swap'
     
            endif
         endif
         lrem_out = .false.

c *** move to the out region
c *** j -> out case
         
         if ( lcluster1 ) then
            wbias_rem = wbias_rem/(ncmt(1,imolty)-1.0d0)
         else
            wbias_rem = wbias_rem/dble(ncmt(1,jmolty))
            if ( lene_w ) then
               wbias_rem = wbias_rem*ene_wi/ene_w
            else
               wbias_rem = wbias_rem/dble(neighj_num)   
            endif
         endif

C     Compute weights for the molecule to be removed from boxrem

c *** select a position of the first/starting unit at RANDOM ***
c *** and calculate the boltzmann weight                     ***
c *** for the chain to be REMOVED                           ***
         rxp(1,1) = rxu(irem,1)
         ryp(1,1) = ryu(irem,1)
         rzp(1,1) = rzu(irem,1)

         if ( lcluster1 ) then
            wbias_ins = wbias_ins/vol_eff
         else
            wbias_ins = wbias_ins/dble(ncmt(1,jmolty)-nij)/vol_eff
         endif

         do icbu = 2,ichoi
c *** choose a random association distance
            rvol = random()
            if ( l2d ) then
               r = dsqrt(vol_min+(vol_max-vol_min)*rvol)
               xi1 = onepi*2d0*random()
               x = r * dcos(xi1)
               y = r * dsin(xi1)
               rxp(1,icbu) = rxu(jins,1) + x
               ryp(1,icbu) = ryu(jins,1) + y
               rzp(1,icbu) = rzu(jins,1)
            else

            r = (vol_max*rvol + 
     &           (1-rvol)*vol_min)**(1.0/3.0d0)
c --- calculate random vector on the unit sphere ---
 129        xi1 = ( 2.0d0 * random() ) - 1.0d0
            xi2 = ( 2.0d0 * random() ) - 1.0d0
            xisq = xi1**2 + xi2**2
            if ( xisq .lt. 1.0d0 ) then
               x = r * 2.0d0 * xi1 * dsqrt( 1.0d0 - xisq )
               y = r * 2.0d0 * xi2 * dsqrt( 1.0d0 - xisq )
               z = r * ( 1.0d0 - 2.0d0 * xisq )
            else
               goto 129
            endif
            rxp(1,icbu) = rxu(jins,1) + x
            ryp(1,icbu) = ryu(jins,1) + y
            rzp(1,icbu) = rzu(jins,1) + z
            endif
         enddo
               
c *** calculate the boltzmann weight of first bead          ***
         
         lnew = .false.
         glist(1) = 1
         call boltz(lnew,.true.,lins_in,ovrlap,irem,irem,imolty,boxrem
     &        ,ichoi,idum,1,glist,0.0d0)
         
c         write(6,*) 'after boltz'

         if ( ovrlap ) then
c            write(6,*) 'disaster: overlap for 1st bead in SWAP'
         endif
c *** calculate the correct weight for the  old  walk ***

         w1rem = 0.0d0
         do ip = 1, ichoi
            w1rem = w1rem + bfac(ip)
         enddo

c --- check for termination of walk ---
         if ( w1rem .lt. softlog ) then 
c            write(6,*) ' run problem : soft overlap in old'
         endif

         v1rem = vtry(1)
         v1remint = vtrinter(1)
         v1remext = vtrext(1)
         v1remelc = vtrelect(1)
         v1remewd = vtrewald(1)
         
         iutry = 1
         call schedule(igrow,imolty,ifrom,iutry,0,2)
c     --- call rosenbluth for old conformation
         call rosenbluth(.false.,lterm,irem,irem,imolty,ifrom
     &        ,boxrem,igrow )
c         write(6,*) 'after rosen2'
         if ( lterm ) then 
c            write(6,*) 'SWAP: rosenbluth old rejected'
            return
         endif
      
         waddold = 1.0d0

         if ( ldual ) then
c     --- store the old grown beads and explict placed beads positions
c     --- 1 = old conformation
            iii = 1
            do j = 1,iunit
               rxuion(j,1) = rxu(irem,j)
               ryuion(j,1) = ryu(irem,j)
               rzuion(j,1) = rzu(irem,j)
               qquion(j,1) = qqu(irem,j)
            enddo

c     --- correct the acceptance rules 
c     --- calculate the Full rcut site-site energy
            istt=1
            iett = iunit
            
            call energy (irem,imolty, v, vintra,vinter,vext,velect
     &           ,vewald, iii, boxrem
     &           ,istt, iett, .true.,ovrlap,.true.,vtorold,.false.)
            
c            write(6,*) 'after energy2'

            if (ovrlap) stop 'disaster ovrlap in old conf SWAP'
            deleo = v - ( voldinter + voldintra+ voldext +voldelect) 
     &           - (v1rem - v1remewd)
            waddold = waddold*dexp(-beta*deleo)
            voldt     = voldt + deleo
            voldinter = vinter - v1remint
            voldintra = vintra
            voldext   = vext - v1remext
            voldelect = velect
         endif
c *** for the insertion

         v1ins = 0d0
         v1insint = 0d0
         w1ins = dble(ichoi)
         waddnew = 1.0d0

c --- call rosenbluth for new conformation
         rxnew(1) = 0d0
         rynew(1) = 0d0
         rznew(1) = 0d0
         call rosenbluth(.true.,lterm,irem,irem,imolty,ifrom
     &        ,boxins,igrow )
         
         vnewt = 0d0
         vnewinter = 0d0
         vnewelect = 0d0
         vnewewald = 0d0
         vnewintra = 0d0
         vnewtg = 0d0
         vnewbb = 0d0
         vnewbvib = 0d0
         vtornew = 0d0
      endif

      bsswap(imolty,1,boxins+nbox) = 
     &     bsswap(imolty,1,boxins+nbox) + 1.0d0


              
      if ( lrem_out .and. lins_in ) then
         bnswap_in(imolty,1) = bnswap_in(imolty,1) + 1.0d0
      elseif ( (.not. lrem_out) .and. (.not. lins_in ) ) then
         bnswap_out(imolty,1) = bnswap_out(imolty,1) + 1.0d0
      endif


c --- Add contributions of the first bead and additional beads:

      vnewt     = vnewt  + v1ins
      vnewinter = vnewinter + v1insint
      
      voldt     = voldt  + v1rem
      voldinter = voldinter+v1remint
      

      weight= w1ins * waddnew * weight
      weiold= w1rem * waddold * weiold
      
      if ( boxins .eq. 1 ) then
         ioffset = 1
      else
         ioffset = -1
      endif

      if ( lmisc ) then
         vbias = fbias(nchbox(1)+ioffset)- fbias(nchbox(1))

      else
c         ncmt(1,imolty) = ncmt(1,imolty)+ioffset
c         ncmt_max = ncmt(1,1)
c         imol_max = 1 
c         do imol = 2,nmolty
c            if (ncmt_max .lt. ncmt(1,imol)) then
c               imol_max = imol
c               ncmt_max = ncmt(1,imol)
c            endif
c         enddo
c         ncmt(1,imolty) = ncmt(1,imolty)-ioffset
         
c         ncmt_max = ncmt(1,1)
c         imol_maxo = 1 
c         do imol = 2,nmolty
c            if (ncmt_max .lt. ncmt(1,imol)) then
c               imol_maxo = imol
c               ncmt_max = ncmt(1,imol)
c            endif
c         enddo
         
c         vbias = fbias(nchbox(1)+ioffset,imol_max)-
c     &        fbias(nchbox(1),imol_maxo)

         ii = (ncmt(1,1)*(n2+1)+ncmt(1,2))*(n3+1)+ncmt(1,3)
         if ( imolty .eq. 1 ) then
            jj = (n2+1)*(n3+1)
         elseif ( imolty .eq. 2 ) then
            jj = n3+1
         else
            jj = 1
         endif

         vbias = fbias(ii+jj*ioffset)-fbias(ii)


      endif

c      write(6,*) 'vbias',vbias
      weight = dexp(vbias)*weight
      
      wnlog = dlog10 ( weight )
      wolog = dlog10 ( weiold )
      wdlog = wnlog - wolog
      
      
c      write(6,*) 'weight:',weight,'weiold:',weiold
      if ( wdlog .lt. -softcut ) then
c         write(6,*) '### underflow in wratio calculation ###'
c         write(6,*) 'weight:',weight,'weiold:',weiold
         return
      endif


      if (boxins.eq.1) then
c --- molecule added to box 1
         wratio = (weight /  weiold ) *  
     +        B(imolty) *
     +        (wbias_ins/wbias_rem)
c        write(6,*) 'wratio:',wratio
      else
c --- molecule removed from box 1
         wratio = (weight /weiold) /
     +        B(imolty) *
     +        (wbias_ins/wbias_rem)
      endif

      if ( random() .le. wratio ) then

c *** we can now accept but we have to test the cluster criteria ***
         
         if ( lcluster2 ) then
            if (boxrem .eq. 1 .and. nchbox(boxrem) .gt. 2 ) then 
               call cluster(nchbox(boxrem),irem,ovrlap,.true.)
               if (ovrlap) return
            endif
         endif

         bnswap(imolty,1,boxins+nbox) = 
     &        bnswap(imolty,1,boxins+nbox) + 1.0d0
         if ( lrem_out .and. lins_in ) then
            bnswap_in(imolty,2) = bnswap_in(imolty,2) + 1.0d0
c            write(93,*) ene3(iins,2)*4+ene4(iins,2)*qqfact,wratio
c            write(91,'(i3)') nchbox(1)
c            write(91,'(6f12.3)') vbox(1),vinterb(1),velectb(1),
c     &           vintrab(1),vbendb(1),vtgb(1)
c            write(91,'(6f12.3)') vnewt,vnewinter,vnewelect,
c     &           vnewintra,vnewbb,vnewtg
c            write(91,'(2i3)') neigh_icnt,neigh_icnt2
c            do ic = 1,neigh_icnt
c               j = neighi(ic)
c               write(91,'(2i3)') neigh_cnt(j),neigh_cnt2(j)
c               x = rxu(j,1) - rxnew(1)
c               y = ryu(j,1) - rynew(1)
c               z = rzu(j,1) - rznew(1)
c               roo = dsqrt(x*x+y*y+z*z)
c               x = rxu(j,4) - rxnew(1)
c               y = ryu(j,4) - rynew(1)
c               z = rzu(j,4) - rznew(1)
c               roh = dsqrt(x*x+y*y+z*z)
c               write(91,'(3f12.6)') roo,roh,dacos((0.893025d0+roo*roo
c     &              -roh*roh)/1.89d0/roo)
c            enddo
         elseif ( (.not. lrem_out) .and. (.not. lins_in ) ) then
            bnswap_out(imolty,2) = bnswap_out(imolty,2) + 1.0d0
c            write(94,*) ene1(irem)*4d0+ene2(irem)*qqfact,wratio
c            write(92,'(i3)') nchbox(1)
c            write(92,'(6f12.3)') vbox(1),vinterb(1),velectb(1),
c     &           vintrab(1),vbendb(1),vtgb(1)
c            write(92,'(6f12.3)') voldt,voldinter,voldelect,
c     &           voldintra,voldbb,voldtg
c            write(92,'(2i3)') neigh_cnt(irem),neigh_cnt2(irem)
c            rxui = rxu(irem,1)
c            ryui = ryu(irem,1)
c            rzui = rzu(irem,1)
c            do ic = 1,neigh_cnt(irem)
c               j = neighbor(ic,irem)
c               write(92,'(2i3)') neigh_cnt(j),neigh_cnt2(j)
c               x = rxu(j,1) - rxui
c               y = ryu(j,1) - ryui
c               z = rzu(j,1) - rzui
c               roo = dsqrt(x*x+y*y+z*z)
c               x = rxu(j,4) - rxui
c               y = ryu(j,4) - ryui
c               z = rzu(j,4) - rzui
c               roh = dsqrt(x*x+y*y+z*z)
c               write(92,'(3f12.6)') roo,roh,dacos((0.893025d0+roo*roo
c     &              -roh*roh)/1.89d0/roo)
c            enddo            
         endif

c ---    update energies:

         vbox(boxrem)     = vbox(boxrem)     - voldt - vtorold
	 vinterb(boxrem)  = vinterb(boxrem)  - voldinter
	 velectb(boxrem)  = velectb(boxrem)  - (voldelect+voldewald)
	 vintrab(boxrem)  = vintrab(boxrem)  - voldintra
	 vvibb(boxrem)    = vvibb(boxrem)    - voldbvib
	 vtgb(boxrem)     = vtgb(boxrem)     - voldtg - vtorold
	 vbendb(boxrem)   = vbendb(boxrem)   - voldbb
         vflucqb(boxrem)  = vflucqb(boxrem)  - voldflucq
         
         vbox(boxins)     = vbox(boxins)     + vnewt + vtornew
	 vinterb(boxins)  = vinterb(boxins)  + vnewinter
         velectb(boxins)  = velectb(boxins)  + (vnewelect+vnewewald)
	 vintrab(boxins)  = vintrab(boxins)  + vnewintra
	 vvibb(boxins)    =  vvibb(boxins)   + vnewbvib
	 vtgb(boxins)     = vtgb(boxins)     + vnewtg + vtornew
	 vbendb(boxins)   = vbendb(boxins)   + vnewbb
         vflucqb(boxins)  = vflucqb(boxins)  + vnewflucq

c *** update the neighbor list
         
         if ( boxrem .eq. 1 ) then
            neigh_old = neigh_cnt(irem)
            neigh_cnt(irem) = 0
            if ( lene_w ) then
               do j = 1,nchbox(1)
                  ene1(j) = ene1(j)-ene3(j,1)
                  ene2(j) = ene2(j)-ene4(j,1)
               enddo
            endif
         else
            neigh_old = 0
            if ( lene_w ) then
               do j = 1,nchbox(1)
                  ene1(j) = ene1(j)+ene3(j,2)
                  ene2(j) = ene2(j)+ene4(j,2)
               enddo
               
               ene1(irem) = ene3(iins,2)
               ene2(irem) = ene4(iins,2)
            endif
         endif

         do 10 ic = 1, neigh_old
              
            j = neighbor(ic,irem)
            do ip = 1,neigh_cnt(j)
               if ( neighbor(ip,j) .eq. irem ) then
                  neighbor(ip,j)=neighbor(neigh_cnt(j),j)
                  neigh_cnt(j) = neigh_cnt(j)-1
                  goto 10
               endif
            enddo
 10      continue
         if ( boxins .eq. 1 ) then
            neigh_cnt(irem) = neigh_icnt
         else
            neigh_icnt = 0
         endif

         do ic = 1,neigh_icnt
            j = neighi(ic)
            neighbor(ic,irem)=j
            lneighij = .false.
            do ip = 1,neigh_cnt(j)
               if ( neighbor(ip,j) .eq. irem ) then
                  lneighij = .true.
               endif
            enddo
            if ( .not. lneighij ) then
               neigh_cnt(j) = neigh_cnt(j)+1
               neighbor(neigh_cnt(j),j) = irem
            endif
         enddo
         if ( lene_cut ) then
            if ( boxrem .eq. 1 ) then
               neigh_old = neigh_cnt2(irem)
               neigh_cnt2(irem) = 0
            else
               neigh_old = 0
            endif
            do 20 ic = 1, neigh_old
               j = neighbor2(ic,irem)
               do ip = 1,neigh_cnt2(j)
                  if ( neighbor2(ip,j) .eq. irem ) then
                     neighbor2(ip,j)=neighbor2(neigh_cnt2(j),j)
                     neigh_cnt2(j) = neigh_cnt2(j)-1
                     goto 20
                  endif
               enddo
 20         continue

            if ( boxins .eq. 1 ) then
               neigh_cnt2(irem) = neigh_icnt2
            else
               neigh_icnt2 = 0
            endif
            
            do ic = 1,neigh_icnt2
               j = neighi2(ic)
               neighbor2(ic,irem)=j
               lneighij = .false.
               do ip = 1,neigh_cnt2(j)
                  if ( neighbor2(ip,j) .eq. irem ) then
                     lneighij = .true.
                  endif
               enddo
               if ( .not. lneighij ) then
                  neigh_cnt2(j) = neigh_cnt2(j)+1
                  neighbor2(neigh_cnt2(j),j) = irem
               endif
            enddo
         endif      

         if ( boxins .eq. 2 ) then

c *** switch particle irem with nchbox(1) if boxins = 2

            jchain = nchbox(1)

            if ( irem .ne. jchain ) then
               neigh_old = neigh_cnt(jchain)
               do 11 ic = 1, neigh_old
                     
                  j = neighbor(ic,jchain)
                  do ip = 1,neigh_cnt(j)
                     if ( neighbor(ip,j) .eq. jchain ) then
                        neighbor(ip,j)=irem
                        goto 11
                     endif
                  enddo
 11            continue
               
               neigh_cnt(irem) = neigh_old
               do ic = 1,neigh_old
                  neighbor(ic,irem) = neighbor(ic,jchain)
               enddo
               neigh_cnt(jchain) = 0

               if ( lene_cut ) then
                  neigh_old = neigh_cnt2(jchain)
                  do 24 ic = 1, neigh_old
                     
                     j = neighbor2(ic,jchain)
                     do ip = 1,neigh_cnt2(j)
                        if ( neighbor2(ip,j) .eq. jchain ) then
                           neighbor2(ip,j)=irem
                           goto 24
                        endif
                     enddo
 24               continue
                  neigh_cnt2(irem) = neigh_old
                  do ic = 1,neigh_old
                     neighbor2(ic,irem) = neighbor2(ic,jchain)
                  enddo
                  neigh_cnt2(jchain) = 0
               endif

               jmolty = moltyp(jchain)
               if ( imolty .ne. jmolty ) then
                  moltyp(irem) = jmolty
               endif
               pointp = parpt(irem)
               j = parbox(ncmt(boxrem,imolty),boxrem,imolty)
               parbox(pointp,boxrem,imolty) = j
               parpt(j) = pointp
               
               pointp = parpt(jchain)               
               parbox(pointp,boxrem,jmolty)=irem
               parpt(irem) = pointp
               
c *** switch coordinates
               
               do ic = 1,nunit(jmolty)
                  rxu(irem,ic) = rxu(jchain,ic)
                  ryu(irem,ic) = ryu(jchain,ic)
                  rzu(irem,ic) = rzu(jchain,ic)
                  qqu(irem,ic) = qqu(jchain,ic)
               enddo
               xcm(irem) = xcm(jchain)
               ycm(irem) = ycm(jchain)
               zcm(irem) = zcm(jchain)
               if ( lene_w ) then
                  ene1(irem) = ene1(jchain)
                  ene2(irem) = ene2(jchain)
               endif
            else

               pointp = parpt(irem)
               j = parbox(ncmt(boxrem,imolty),boxrem,imolty)
               parbox(pointp,boxrem,imolty) = j
               parpt(j) = pointp

            endif
            
         else
            nboxi(irem) = boxins
            parbox(ncmt(boxins,imolty)+1,boxins,imolty)= irem
            parpt(irem) = ncmt(boxins,imolty)+1
         endif

c ---    update book keeping

c         nboxi(irem) = boxins
         
c         parbox(ncmt(boxins,imolty)+1,boxins,imolty)= irem
c         parbox(pointp,boxrem,imolty)=
c     &        parbox(ncmt(boxrem,imolty),boxrem,imolty)
c         parbox(ncmt(boxrem,imolty),boxrem,imolty)=0
         
         nchbox(boxins) = nchbox(boxins) + 1
         nchbox(boxrem) = nchbox(boxrem) - 1
         ncmt(boxins,imolty) = ncmt(boxins,imolty) + 1
         ncmt(boxrem,imolty) = ncmt(boxrem,imolty) - 1


         if ( boxins .eq. 1 ) then
            do ic = 1,igrow
               rxu(irem,ic) = rxnew(ic)
               ryu(irem,ic) = rynew(ic)
               rzu(irem,ic) = rznew(ic)
               qqu(irem,ic) = qqu(iins,ic)
            enddo
            do ic = igrow+1,iunit
               rxu(irem,ic) = rxuion(ic,2)
               ryu(irem,ic) = ryuion(ic,2)
               rzu(irem,ic) = rzuion(ic,2)
               qqu(irem,ic) = qqu(iins,ic)
            enddo
         else
            do ic = 1,igrow
               rxu_gas(imolty,ic) = rxnew(ic)
               ryu_gas(imolty,ic) = rynew(ic)
               rzu_gas(imolty,ic) = rznew(ic)
            enddo
          endif

c ---    update center of mass
         if (boxins .eq. 1 ) then
            call ctrmas(.false.,boxins,irem,3)
            if (lradgyr) then
               xclust = xclust + (xcm(irem)-xclust)/nchbox(1)
               yclust = yclust + (ycm(irem)-yclust)/nchbox(1)
               zclust = zclust + (zcm(irem)-zclust)/nchbox(1)
            endif
         else
            if (lradgyr) then
               xclust = xclust - (xcm(irem)-xclust)/nchbox(1)
               yclust = yclust - (ycm(irem)-yclust)/nchbox(1)
               zclust = zclust - (zcm(irem)-zclust)/nchbox(1)
            endif
         endif


c         if ( boxins .eq. 1 ) 
c     &        write(6,*) 'SWAP MOVE ACCEPTED',irem,boxrem,boxins,
c     &        neigh_icnt2

      endif
c      write(6,*) irem,'end SWAP'
 
c -----------------------------------------------------------------
      return
      end




