      function vtorso( thetac, itype )

      implicit none

      integer itype
      double precision vtorso, thetac, theta
      double precision tac2,tac3,tac4,tac5,tac6,tac7

c *** common blocks ***
      include 'conver.inc' 
      include 'contorsion.inc'

c ----------------------------------------------------------------

      if ( itype .ge. 1 .and. itype .le. 7 ) then
c - parameters for linear and branched alkane molecules - ALKANE CURRENTLY USED
c - 5 + 6 parameters for alcohols
c - Jorgensen potential
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)+onepi
c --- remember: 1 + cos( theta+onepi ) = 1 - cos( theta )
         vtorso = vtt0(itype) + vtt1(itype)*(1.0d0-thetac) +
     +            vtt2(itype)*(1.d0-dcos(2.d0*theta)) +
     +            vtt3(itype)*(1.d0+dcos(3.d0*theta))

      elseif ( itype .eq. 8 ) then
c - Cummings torsional potential
c - PERFLUOROCARBON CURRENTLY USED starting 10-1-97
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0

         tac2 = thetac*thetac
         tac3 = tac2*thetac
         tac4 = tac3*thetac
         tac5 = tac4*thetac
         tac6 = tac5*thetac
         tac7 = tac6*thetac
c extra displacement is to get the curve above zero
         vtorso = 595.4d0 + 345.0d0
     &        -(282.7d0)*thetac 
     &        +(1355.2d0)*tac2 
     &        +(6800d0)*tac3
     &        -(7875.3d0)*tac4
     &        -(14168.0d0)*tac5
     &        +(9213.7d0)*tac6
     &        +(4123.7d0)*tac7
c         write(6,*) 'thetac,vtorso',thetac,vtorsoAK
c - Roethlisberger torsional potential for linear perfluorocarbon
c - PERFLUOROCARBON no longer USED
c         if (thetac.gt.1.d0) thetac=1.0d0
c         if (thetac.lt.-1.d0) thetac=-1.0d0
c         theta=dacos(thetac)
c         vtorso = - 269.5616d0 + 503.6229d0*(1.0d0-thetac)
c     &            + 679.921d0*(1.0d0-(dcos(3.0d0*theta)))
c     &            + 3.0085d0*(1.0d0-thetac)**5
c     &            + 420.5883d0*dexp(-30.0d0*theta**2)

      elseif ( itype .eq. 9 ) then
c  Toxvaerd II Torsion potential parms:  to be used for anisotropic alkanes
c  JCP 94, 5650-54 (1991)
         vtorso = 1037.76d0 + 2426.07d0*thetac + 81.64d0*thetac**2
     &    -3129.46d0*thetac**3 -163.28d0*thetac**4 -252.73d0*thetac**5
c      elseif ( itype .ge. 1 .and. itype .le. 3 ) then
c - parameters for improper torsion in carboxylic headgroup
c - C'-C2-O-O'
c         if (thetac.gt.1.d0) thetac=1.0d0
c         if (thetac.lt.-1.d0) thetac=-1.0d0
c         theta=dacos(thetac)+onepi
c         vtorso = vtt2(itype)*(1.d00-dcos(2.d00*theta))
      elseif ( itype .eq. 10 ) then
c        --- dummy torsion just to set up inclusion table right
         vtorso = 0.0d0

      elseif ( itype .eq. 11 .or. itype .eq. 12) then
c - parameters for trans and conformations of double bonds
c - derived by Marcus Martin using data from pcmodel for butene
c   trans torsion paramter 4-14-99 MGM

         if (thetac .gt. 1.0d0) then
            theta = 0.0d0
         elseif (thetac .lt. -1.0d0) then
            theta = onepi
         else
            theta = dacos(thetac)
         endif

         vtorso = vtt0(itype)*(theta - vtt1(itype) )**2.0d0

      elseif ( itype .eq. 13 ) then
c   acetic acid torsional potential H3C--C--O--H
c   modified from J Phys Chem 94, 1683-1686 1990
c   had to divide the potential by 2 and did a bit of trig.
         vtorso = 630.0d0*(1.0d0 - thetac) 
     &        + 1562.4d0*(1.0d0 - thetac*thetac)

      elseif ( itype .eq. 14 ) then
c   acetic acid torsional potential  O==C--O--H
c   modified from J Phys Chem 94, 1683-1686 1990
c   had to divide the potential by 2 and did a bit of trig.
         vtorso = 630.0d0*(1.0d0 + thetac) 
     &        + 1562.4d0*(1.0d0 - thetac*thetac)

      elseif ( itype .eq. 15 ) then
c - Rice torsional potential for linear perfluorocarbons - OLD-FASHIONED
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)
         vtorso = 1784.2812d0 + 1357.1705d0*thetac - 1444.08d0*thetac**2
     &          + 1176.6605d0*thetac**3 + 2888.1600d0*thetac**4 
     &          - 7166.9209d0*thetac**5
     &          + 1684.7600d0*dexp(-12.7176d0*theta**2)

      elseif ( itype .eq. 16 ) then
c - normal parameters for linear molecules - OLD-FASHIONED ALKANE
c - Ryckaert-Bellemans potential
         vtorso = 1116.0d0 + 1462.0d0*thetac - 1578.0d0*thetac**2
     &    - 368.1d0*thetac**3 + 3156.1d0*thetac**4 - 3788.0d0*thetac**5

      elseif ( itype .eq. 19 ) then
c --- methyl group rotations explicit  H-C-C-H McQuarrie
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)
         vtorso = 716.77d0*(1.0d0-dcos(3.0d0*theta))

      elseif (itype .eq. 20) then
c --   methyl group rotation explicit hydrogen model Scott+Scheraga
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)
         vtorso = 853.93d0*(1.0d0-dcos(3.0d0*theta))
      elseif (itype .eq. 21) then
c --   methyl group rotation explicit hydrogen model Scott+Scheraga
c --   designed to be used with fully flexible (ie divided by 3)
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)
         vtorso = 284.64d0*(1.0d0-dcos(3.0d0*theta))
      elseif ( itype .eq. 22) then
c --   torsional motion about the central C-O in ester
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)+onepi
         vtorso = 1253.07*(1.0d0-thetac) + 
     &        1560.08*(1.0d0-dcos(2.0d0*theta))

      elseif ( itype .eq. 23) then
c - Jorgensen potential for segment containing a (H-)-O-C-(CH3)_3 OPLS
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)+onepi
c --- remember: 1 + cos( theta+onepi ) = 1 - cos( theta )
         vtorso = 163.56d0*(1.d00+dcos(3.d0*theta))
         
      elseif ( itype .eq. 24) then
         vtorso = 0.0d0

      elseif ( itype .eq. 25) then
c *** OPLS C-C-O-C for ether paper JCC 1990
         if (thetac.gt.1.d0) thetac=1.0d0
         if (thetac.lt.-1.d0) thetac=-1.0d0
         theta=dacos(thetac)
         vtorso = 725.35d0*(1.d0 + dcos(theta)) -
     &        163.75d0*(1.d0 - dcos(2.d0*theta)) +
     &        558.2d0*(1.d0 + dcos(3.d0*theta))
         
      else
         stop 'you picked a non-defined torsional type'
      endif

      return
      end
